import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:flutter_sticky_widgets/flutter_sticky_widgets.dart';
import 'package:ui_sdk/components/UIkToolTip.dart';
import 'package:ui_sdk/components/UikAppBar.dart';
import 'package:ui_sdk/components/UikCenterRow.dart';
import 'package:ui_sdk/components/UikChips.dart';
import 'package:ui_sdk/components/UikColumn.dart';
import 'package:ui_sdk/components/UikDiscount.dart';
import 'package:ui_sdk/components/UikFilterRowThreeComponent.dart';
import 'package:ui_sdk/components/UikHomeCardFive.dart';
import 'package:ui_sdk/components/UikHomeCardOne.dart';
import 'package:ui_sdk/components/UikHomeCardThree.dart';
import 'package:ui_sdk/components/UikHomeCardTwelve.dart';
import 'package:ui_sdk/components/UikHomeCardTwo.dart';
import 'package:ui_sdk/components/UikIcon.dart';
import 'package:ui_sdk/components/UikIconText.dart';
import 'package:ui_sdk/components/UikImage.dart';
import 'package:ui_sdk/components/UikListTile.dart';
import 'package:ui_sdk/components/UikListTileContainer.dart';
import 'package:ui_sdk/components/UikListViewBuilder.dart';
import 'package:ui_sdk/components/UikLokalAcademyCard.dart';
import 'package:ui_sdk/components/UikLottieView.dart';
import 'package:ui_sdk/components/UikMembership.dart';
import 'package:ui_sdk/components/UikNavbar.dart';
import 'package:ui_sdk/components/UikOrderProductCard.dart';
import 'package:ui_sdk/components/UikPageControl.dart';
import 'package:ui_sdk/components/UikPagination.dart';
import 'package:ui_sdk/components/UikPopover.dart';
import 'package:ui_sdk/components/UikProductCard.dart';
import 'package:ui_sdk/components/UikProductCardBig.dart';
import 'package:ui_sdk/components/UikProductCardGrid.dart';
import 'package:ui_sdk/components/UikProductPageContainer.dart';
import 'package:ui_sdk/components/UikProductPageInformationContainer.dart';
import 'package:ui_sdk/components/UikProductScreenTagsRow.dart';
import 'package:ui_sdk/components/UikProfile.dart';
import 'package:ui_sdk/components/UikRadioButtonList.dart';
import 'package:ui_sdk/components/UikScreenTitleSubtitle.dart';
import 'package:ui_sdk/components/UikScrollProducts.dart';
import 'package:ui_sdk/components/UikSelectFiles.dart';
import 'package:ui_sdk/components/UikSimpleColumn.dart';
import 'package:ui_sdk/components/UikSimpleRow.dart';
import 'package:ui_sdk/components/UikSortFilter.dart';
import 'package:ui_sdk/components/UikSpacer.dart';
import 'package:ui_sdk/components/UikTags.dart';
import 'package:ui_sdk/components/UikTextArea.dart';
import 'package:ui_sdk/components/UikTextIconButton.dart';
import 'package:ui_sdk/components/UikTop100.dart';
import 'package:ui_sdk/components/UikTopBar.dart';
import 'package:ui_sdk/components/UikUploadPhoto.dart';
import 'package:ui_sdk/components/UikVideoPlayer.dart';
import 'package:ui_sdk/components/UikWebView.dart';
import 'package:ui_sdk/components/UikmyAgent.dart';
import 'package:ui_sdk/props/ProductScreenTagsRow.dart';
import 'package:ui_sdk/props/StandardScreenResponse.dart';
import 'package:ui_sdk/props/UikAccordionNewProps.dart';
import 'package:ui_sdk/props/UikActionSheetProps.dart';
import 'package:ui_sdk/props/UikAppBarProps.dart';
import 'package:ui_sdk/props/UikAvatarProps.dart';
import 'package:ui_sdk/props/UikBagItemProps.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/props/UikCartTextHorizontalProps.dart';
import 'package:ui_sdk/props/UikCellProps.dart';
import 'package:ui_sdk/props/UikCenterRowProps.dart';
import 'package:ui_sdk/props/UikChipsProps.dart';
import 'package:ui_sdk/props/UikColumnProps.dart';
import 'package:ui_sdk/props/UikContainerTextProps.dart';
import 'package:ui_sdk/props/UikDiscountProps.dart';
import 'package:ui_sdk/props/UikDividerProps.dart';
import 'package:ui_sdk/props/UikDropDownProps.dart';
import 'package:ui_sdk/props/UikEarningCardProps.dart';
import 'package:ui_sdk/props/UikFilterOptionProps.dart';
import 'package:ui_sdk/props/UikFilterRowThreeComponentProps.dart';
import 'package:ui_sdk/props/UikHeadlineProps.dart';
import 'package:ui_sdk/props/UikHomeCardEightProps.dart';
import 'package:ui_sdk/props/UikHomeCardFiveProps.dart';
import 'package:ui_sdk/props/UikHomeCardNineProps.dart';
import 'package:ui_sdk/props/UikHomeCardOneProps.dart';
import 'package:ui_sdk/props/UikHomeCardSevenProps.dart';
import 'package:ui_sdk/props/UikHomeCardTenProps.dart';
import 'package:ui_sdk/props/UikHomeCardThreeProps.dart';
import 'package:ui_sdk/props/UikHomeCardTwelveProps.dart';
import 'package:ui_sdk/props/UikHomeCardTwoProps.dart';
import 'package:ui_sdk/props/UikIconProps.dart';
import 'package:ui_sdk/props/UikIconTextProps.dart';
import 'package:ui_sdk/props/UikImageProps.dart';
import 'package:ui_sdk/props/UikJarItemProps.dart';
import 'package:ui_sdk/props/UikListItemCustomerProps.dart';
import 'package:ui_sdk/props/UikListItemsProps.dart';
import 'package:ui_sdk/props/UikListTileContainerProps.dart';
import 'package:ui_sdk/props/UikListTileProps.dart';
import 'package:ui_sdk/props/UikListTilesProps.dart';
import 'package:ui_sdk/props/UikListViewBuilderProps.dart';
import 'package:ui_sdk/props/UikLokalAcademyCardProps.dart';
import 'package:ui_sdk/props/UikLottieViewProps.dart';
import 'package:ui_sdk/props/UikMembershipProps.dart';
import 'package:ui_sdk/props/UikMultiButtonRowProps.dart';
import 'package:ui_sdk/props/UikMyAgentRewardProps.dart';
import 'package:ui_sdk/props/UikMyCustomerDetailsProps.dart';
import 'package:ui_sdk/props/UikMyOrderCardProps.dart';
import 'package:ui_sdk/props/UikMyOrderProps.dart';
import 'package:ui_sdk/props/UikNavbarProps.dart';
import 'package:ui_sdk/props/UikNewReviewProps.dart';
import 'package:ui_sdk/props/UikNoInternetProps.dart';
import 'package:ui_sdk/props/UikOrderProductCardProps.dart';
import 'package:ui_sdk/props/UikPageControlProps.dart';
import 'package:ui_sdk/props/UikPaginationProps.dart';
import 'package:ui_sdk/props/UikPopoverProps.dart';
import 'package:ui_sdk/props/UikProductCardBigProps.dart';
import 'package:ui_sdk/props/UikProductCardGridProps.dart';
import 'package:ui_sdk/props/UikProductCardProps.dart';
import 'package:ui_sdk/props/UikProductImageTitlePriceCardProps.dart';
import 'package:ui_sdk/props/UikProductInformationProps.dart';
import 'package:ui_sdk/props/UikProductInfornationCompprops.dart';
import 'package:ui_sdk/props/UikProductPageContainerProps.dart';
import 'package:ui_sdk/props/UikProductPageInformationContainerProps.dart';
import 'package:ui_sdk/props/UikProductPagePaginationProps.dart';
import 'package:ui_sdk/props/UikProductProps.dart';
import 'package:ui_sdk/props/UikProfileProps.dart';
import 'package:ui_sdk/props/UikRadioButtonListProps.dart';
import 'package:ui_sdk/props/UikRatingProps.dart';
import 'package:ui_sdk/props/UikReviewProps.dart';
import 'package:ui_sdk/props/UikRowListItemProps.dart';
import 'package:ui_sdk/props/UikRowProps.dart';
import 'package:ui_sdk/props/UikRowTextProps.dart';
import 'package:ui_sdk/props/UikScreenTitleSubtitleProps.dart';
import 'package:ui_sdk/props/UikSearchProps.dart';
import 'package:ui_sdk/props/UikSelectFilesProps.dart';
import 'package:ui_sdk/props/UikShortAndFilterProps.dart';
import 'package:ui_sdk/props/UikSimpleColumnProps.dart';
import 'package:ui_sdk/props/UikSimpleRowProps.dart';
import 'package:ui_sdk/props/UikSortFilterProps.dart';
import 'package:ui_sdk/props/UikSpacerProps.dart';
import 'package:ui_sdk/props/UikStackImageIconProps.dart';
import 'package:ui_sdk/props/UikStepperProps.dart';
import 'package:ui_sdk/props/UikSwitchProps.dart';
import 'package:ui_sdk/props/UikTabBarProps.dart';
import 'package:ui_sdk/props/UikTagsProps.dart';
import 'package:ui_sdk/props/UikTextAreaProps.dart';
import 'package:ui_sdk/props/UikTextChipListProps.dart';
import 'package:ui_sdk/props/UikTextDividerProps.dart';
import 'package:ui_sdk/props/UikTextFieldProps.dart';
import 'package:ui_sdk/props/UikTextIconButtonProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:ui_sdk/props/UikTextRadioButtonProps.dart';
import 'package:ui_sdk/props/UikThreeColumnProductProps.dart';
import 'package:ui_sdk/props/UikThreeColumnTileListProps.dart';
import 'package:ui_sdk/props/UikThreeColumnTileProps.dart';
import 'package:ui_sdk/props/UikThreeComponentRowProps.dart';
import 'package:ui_sdk/props/UikThreeDividerProps.dart';
import 'package:ui_sdk/props/UikThreeTextCardProps.dart';
import 'package:ui_sdk/props/UikTopBarProps.dart';
import 'package:ui_sdk/props/UikTotalProps.dart';
import 'package:ui_sdk/props/UikTwoComponentRowProps.dart';
import 'package:ui_sdk/props/UikUploadPhotoProps.dart';
import 'package:ui_sdk/props/UikVideoPlayerNewProps.dart';
import 'package:ui_sdk/props/UikVideoPlayerProps.dart';
import 'package:ui_sdk/props/UikWebViewWithHtmlProps.dart';
import 'package:ui_sdk/props/UikmyAgentProps.dart';

import 'components/UikAccordionNew.dart';
import 'components/UikActionSheet.dart';
import 'components/UikAnimatedImage.dart';
import 'components/UikAvatar.dart';
import 'components/UikBagItem.dart';
import 'components/UikButton.dart';
import 'components/UikCartTextHorizontal.dart';
import 'components/UikCell.dart';
import 'components/UikContainerText.dart';
import 'components/UikDivider.dart';
import 'components/UikDropDown.dart';
import 'components/UikEarningCard.dart';
import 'components/UikFilterOption.dart';
import 'components/UikGroupAvatar.dart';
import 'components/UikHeadline.dart';
import 'components/UikHomeCardEight.dart';
import 'components/UikHomeCardEleven.dart';
import 'components/UikHomeCardNine.dart';
import 'components/UikHomeCardSeven.dart';
import 'components/UikHomeCardTen.dart';
import 'components/UikJarItem.dart';
import 'components/UikListItemCustomer.dart';
import 'components/UikListItems.dart';
import 'components/UikListTiles.dart';
import 'components/UikMultiButtonRow.dart';
import 'components/UikMyAgentReward.dart';
import 'components/UikMyCustomerDetails.dart';
import 'components/UikMyOrder.dart';
import 'components/UikMyOrderCard.dart';
import 'components/UikNewReview.dart';
import 'components/UikNoInternet.dart';
import 'components/UikOrderAgainProduct.dart';
import 'components/UikOtp.dart';
import 'components/UikProduct.dart';
import 'components/UikProductImageTitlePriceCard.dart';
import 'components/UikProductInformation.dart';
import 'components/UikProductInformationComp.dart';
import 'components/UikProductPagePagination.dart';
import 'components/UikRadioButton.dart';
import 'components/UikRating.dart';
import 'components/UikReview.dart';
import 'components/UikRow.dart';
import 'components/UikRowListItem.dart';
import 'components/UikRowText.dart';
import 'components/UikScrollOrderAgainProduct.dart';
import 'components/UikSearch.dart';
import 'components/UikSelect.dart';
import 'components/UikShortAndFilter.dart';
import 'components/UikSlidder.dart';
import 'components/UikSortPage.dart';
import 'components/UikStackImageIcon.dart';
import 'components/UikStepper.dart';
import 'components/UikSwitch.dart';
import 'components/UikTab.dart';
import 'components/UikTabBar.dart';
import 'components/UikText.dart';
import 'components/UikTextChipList.dart';
import 'components/UikTextDivider.dart';
import 'components/UikTextField.dart';
import 'components/UikTextRadioButton.dart';
import 'components/UikThreeColumnProduct.dart';
import 'components/UikThreeColumnTIleList.dart';
import 'components/UikThreeColumnTile.dart';
import 'components/UikThreeComponentRow.dart';
import 'components/UikThreeDivider.dart';
import 'components/UikThreeTextCard.dart';
import 'components/UikTotal.dart';
import 'components/UikTwoComponentRow.dart';
import 'components/UikVideoPlayerNew.dart';
import 'components/UikWidget.dart';
import 'components/WidgetType.dart';
import 'components/uikTextChip.dart';
import 'components/UikCard.dart';
import 'props/UikCardProps.dart';
import 'props/UikAnimatedImageProps.dart';
//import 'props/UikGroupAvatar.dart';
import 'props/UikGroupAvatarProps.dart';
import 'props/UikHomeCardElevenProps.dart';
import 'props/UikOrderAgainProductProps.dart';
import 'props/UikOtpProps.dart';
import 'props/UikRadioButtonProps.dart';
import 'props/UikScrollOrderAgainProductProps.dart';
import 'props/UikScrollProductsProps.dart';
import 'props/UikSelectProps.dart';
import 'props/UikSlidderProps.dart';
import 'props/UikSortPageProps.dart';
import 'props/UikTabProps.dart';
import 'props/UikTextChipProps.dart';
import 'props/UikToolTipProps.dart';
import 'props/UikTop100Props.dart';

enum Status { none, run, stop, pause }

extension StatusEx on Status {
  String get name {
    switch (this) {
      case Status.run:
        return 'RUN';
      case Status.stop:
        return 'STOP';
      default:
        return "NONE";
    }
  }
}

class Renderer {
  dynamic getWidget(String? wType, dynamic wData) {
    switch (wType) {
      case 'UikSimpleColumn':
        return UikSimpleColumn(
            WidgetType.UikSimpleColumn, UikSimpleColumnProps.fromJson(wData));
      case 'UikSimpleRow':
        return UikSimpleRow(
            WidgetType.UikSimpleRow, UikSimpleRowProps.fromJson(wData));
      case 'UikCard':
        return UikCard(WidgetType.UikCard, UikCardProps.fromJson(wData));
      case 'UikEarningCard':
        return UikEarningCard(
            WidgetType.UikEarningCard, UikEarningCardProps.fromJson(wData));
      case "UikImage":
        return UikImage(WidgetType.UikImage, UikImageProps.fromJson(wData));
      case "UikThreeColumnProduct":
        return UikThreeColumnProduct(WidgetType.UikThreeColumnProduct,
            UikThreeColumnProductProps.fromJson(wData));
      case "UikText":
        return UikText(WidgetType.UikText, UikTextProps.fromJson(wData));
      case "UikButton":
        return UikButton(WidgetType.UikButton, UikButtonProps.fromJson(wData));
      case "UikMembership":
        return UikMembership(
            WidgetType.UikMembership, UikMembershipProps.fromJson(wData));
      case "UikNavbar":
        return UikNavbar(WidgetType.UikNavbar, UikNavbarProps.fromJson(wData));
      case "UikPopover":
        return UikPopover(
            WidgetType.UikPopover, UikPopoverProps.fromJson(wData));
      case "UikChips":
        return UikChips(WidgetType.UikChips, UikChipsProps.fromJson(wData));
      case "UikSwitch":
        return UikSwitch(WidgetType.UikSwitch, UikSwitchProps.fromJson(wData));
      case "UikCell":
        return UikCell(WidgetType.UikCell, UikCellProps.fromJson(wData));
      case "UikDivider":
        return UikDivider(
            WidgetType.UikDivider, UikDividerProps.fromJson(wData));
      case "UikIcon":
        return UikIcon(WidgetType.UikIcon, UikIconProps.fromJson(wData));
      case "UikPagination":
        return UikPagination(
            WidgetType.UikPagination, UikPaginationProps.fromJson(wData));
      case "UikListTiles":
        return UikListTiles(
            WidgetType.UikListTiles, UikListTilesProps.fromJson(wData));
      case "UikTextArea":
        return UikTextArea(
            WidgetType.UikTextArea, UikTextAreaProps.fromJson(wData));
      case "UikPageControl":
        return UikPageControl(
            WidgetType.UikPageControl, UikPageControlProps.fromJson(wData));

      case "UikAvatar":
        return UikAvatar(WidgetType.UikAvatar, UikAvatarProps.fromJson(wData));
      case "UikRadioButton":
        return UikRadioButton(
            WidgetType.UikRadioButton, UikRadioButtonProps.fromJson(wData));
      case "UikSlidder":
        return UikSlidder(
            WidgetType.UikSlidder, UikSlidderProps.fromJson(wData));
      case "UikListItems":
        return UikListItems(
            WidgetType.UikListItems, UikListItemsProps.fromJson(wData));

      case "UikGroupAvatar":
        return UikGroupAvatar(
            WidgetType.UikGroupAvatar, UikGroupAvatarProps.fromJson(wData));
      case "UikListTileContainer":
        return UikListTileContainer(WidgetType.UikListTileContainer,
            UikListTileContainerProps.fromJson(wData));

      case "UikTab":
        return UikTab(WidgetType.UikTab, UikTabProps.fromJson(wData));
      case "UikTabBar":
        return UikTabBar(WidgetType.UikTabBar, UikTabBarProps.fromJson(wData));
      case "UikSelect":
        return UikSelect(WidgetType.UikSelect, UikSelectProps.fromJson(wData));
      case "UikToolTip":
        return UikToolTip(
            WidgetType.UikToolTip, UikToolTipProps.fromJson(wData));

      case "UikProduct":
        return UikProduct(
            WidgetType.UikProduct, UikProductProps.fromJson(wData));
      case "UikDiscount":
        return UikDiscount(
            WidgetType.UikDiscount, UikDiscountProps.fromJson(wData));
      case "UikScrollProducts":
        return UikScrollProducts(WidgetType.UikScrollProducts,
            UikScrollProductsProps.fromJson(wData));
      case "UikTop100":
        return UikTop100(WidgetType.UikTop100, UikTop100Props.fromJson(wData));
      case "UikOtp":
        return UikOtp(WidgetType.UikOtp, UikOtpProps.fromJson(wData));
      case "UikStepper":
        return UikStepper(
            WidgetType.UikStepper, UikStepperProps.fromJson(wData));
      case "UikBagItem":
        return UikBagItem(
            WidgetType.UikBagItem, UikBagItemProps.fromJson(wData));
      case "UikTextField":
        return UikTextField(
            WidgetType.UikTextField, UikTextFieldProps.fromJson(wData));
      case "UikProductCard":
        return UikProductCard(
            WidgetType.UikProductCard, UikProductCardProps.fromJson(wData));

      case "UikSearch":
        return UikSearch(WidgetType.UikSearch, UikSearchProps.fromJson(wData));
      case "UikProductPagePagination":
        return UikProductPagePagination(WidgetType.UikProductPagePagination,
            UikProductPagePaginationProps.fromJson(wData));
      case "UikCartTextHorizontal":
        return UikCartTextHorizontal(WidgetType.UikCartTextHorizontal,
            UikCartTextHorizontalProps.fromJson(wData));
      // case "UikSnackBar" :
      //   return UikSnackBar(WidgetType.UikText, UikSnackBarProps("Snack Me"));
      case "UikVideoPlayer":
        return UikVideoPlayer(
            WidgetType.UikVideoPlayer, UikVideoPlayerProps.fromJson(wData));

      case "UikProductScreenTagsRow":
        return UikProductScreenTagsRow(WidgetType.UikProductScreenTagsRow,
            UikProductScreenTagsRowProps.fromJson(wData));
      case "UikProductPageContainer":
        return UikProductPageContainer(WidgetType.UikProductPageContainer,
            UikProductPageContainerProps.fromJson(wData));

      case "UikProductPageInformationContainer":
        return UikProductPageInformationContainer(
            WidgetType.UikProductPageInformationContainer,
            UikProductPageInformationContainerProps.fromJson(wData));
      case "UikProductCardBig":
        return UikProductCardBig(WidgetType.UikProductCardBig,
            UikProductCardBigProps.fromJson(wData));
      case "UikProductCardGrid":
        return UikProductCardGrid(WidgetType.UikProductCardGrid,
            UikProductCardGridProps.fromJson(wData));
      case "UikTags":
        return UikTags(WidgetType.UikTags, UikTagsProps.fromJson(wData));

      case "UikSortFilter":
        return UikSortFilter(
            WidgetType.UikSortFilter, UikSortFilterProps.fromJson(wData));

        // case "UikSnackBar" :
        //   return UikSnackBar(WidgetType.UikText, UikSnackBarProps("Snack Me"));
        return UikProductPageInformationContainer(WidgetType.UikText,
            UikProductPageInformationContainerProps.fromJson(wData));
      case "UikHomeCardOne":
        return UikHomeCardOne(
            WidgetType.UikHomeCardOne, UikHomeCardOneProps.fromJson(wData));
      case "UikAppBar":
        return UikAppBar(WidgetType.UikAppBar, UikAppBarProps.fromJson(wData));
      case "UikHomeCardTwo":
        return UikHomeCardTwo(
            WidgetType.UikHomeCardTwo, UikHomeCardTwoProps.fromJson(wData));
      case "UikStackedImage":
        return UikImage(
            WidgetType.UikStackedImage, UikImageProps.fromJson(wData));
      case "UikHomeCardThree":
        return UikHomeCardThree(
            WidgetType.UikHomeCardThree, UikHomeCardThreeProps.fromJson(wData));
      case "UikHomeCardEleven":
        return UikHomeCardEleven(WidgetType.UikHomeCardEleven,
            UikHomeCardElevenProps.fromJson(wData));
      case "UikHomeCardTwelve":
        return UikHomeCardTwelve(WidgetType.UikHomeCardTwelve,
            UikHomeCardTwelveProps.fromJson(wData));
      case "UikHomeCardFour":
        return UikProductPageInformationContainer(WidgetType.UikHomeCardFour,
            UikProductPageInformationContainerProps.fromJson(wData));
      case "UikHomeCardFive":
        return UikHomeCardFive(
            WidgetType.UikHomeCardFive, UikHomeCardFiveProps.fromJson(wData));

      case "UikOrderAgainProduct":
        return UikOrderAgainProduct(WidgetType.UikOrderAgainProduct,
            UikOrderAgainProductProps.fromJson(wData));
      case "UikScrollOrderAgainProduct":
        return UikScrollOrderAgainProduct(WidgetType.UikScrollOrderAgainProduct,
            UikScrollOrderAgainProductProps.fromJson(wData));
      case "UikFilterRowThreeComponent":
        return UikFilterRowThreeComponent(WidgetType.UikFilterRowThreeComponent,
            UikFilterRowThreeComponentProps.fromJson(wData));
      case "UikThreeDivider":
        return UikThreeDivider(
            WidgetType.UikThreeDivider, UikThreeDividerProps.fromJson(wData));
      case "UikJarItem":
        return UikJarItem(
            WidgetType.UikJarItem, UikJarItemProps.fromJson(wData));
      case "UikMyOrder":
        return UikMyOrder(
            WidgetType.UikMyOrder, UikMyOrderProps.fromJson(wData));
      case "UikShortAndFilter":
        return UikShortAndFilter(WidgetType.UikShortAndFilter,
            UikShortAndFilterProps.fromJson(wData));
      case "UikTotal":
        return UikTotal(WidgetType.UikTotal, UikTotalProps.fromJson(wData));
      case "UikHeadline":
        return UikHeadline(
            WidgetType.UikHeadline, UikHeadlineProps.fromJson(wData));
        // case "UikAddress":
        //   return UikAddress(WidgetType.UikText, UikAddressProps.fromJson(wData));
        return UikJarItem(WidgetType.UikText, UikJarItemProps.fromJson(wData));
      case "UikUploadPhoto":
        return UikUploadPhoto(
            WidgetType.UikUploadPhoto, UikUploadPhotoProps.fromJson(wData));
      case "UikContainerText":
        return UikContainerText(
            WidgetType.UikContainerText, UikContainerTextProps.fromJson(wData));
      case "UikFilterOption":
        return UikFilterOption(
            WidgetType.UikFilterOption, UikFilterOptionProps.fromJson(wData));
      case "UikThreeComponentRow":
        return UikThreeComponentRow(WidgetType.UikThreeComponentRow,
            UikThreeComponentRowProps.fromJson(wData));
      case "UikTextRadioButton":
        return UikTextRadioButton(WidgetType.UikTextRadioButton,
            UikTextRadioButtonProps.fromJson(wData));
      case "UikProductInformationComp":
        return UikProductInformationComp(WidgetType.UikProductInformationComp,
            UikProductInformationCompProps.fromJson(wData));
      case "UikTwoComponentRow":
        return UikTwoComponentRow(WidgetType.UikTwoComponentRow,
            UikTwoComponentRowProps.fromJson(wData));
      case "UikProductInformation":
        return UikProductInformation(WidgetType.UikProductInformation,
            UikProductInformationProps.fromJson(wData));
      case "UikActionSheet":
        return UikActionSheet(
            WidgetType.UikActionSheet, UikActionSheetProps.fromJson(wData));
      case "UikNoInternet":
        return UikNoInternet(
            WidgetType.UikNoInternet, UikNoInternetProps.fromJson(wData));
        return UikActionSheet(
            WidgetType.UikText, UikActionSheetProps.fromJson(wData));
        return UikFilterOption(
            WidgetType.UikText, UikFilterOptionProps.fromJson(wData));
      case "UikTopBar":
        return UikTopBar(WidgetType.UikTopBar, UikTopBarProps.fromJson(wData));
      case "UikListTile":
        return UikListTile(
            WidgetType.UikListTile, UikListTileProps.fromJson(wData));
      case "UikScreenTitleSubtitle":
        return UikScreenTitleSubtitle(WidgetType.UikScreenTitleSubtitle,
            UikScreenTitleSubtitleProps.fromJson(wData));
      case "UiklistViewBuilder":
        return UikListViewBuilder(WidgetType.UiklistViewBuilder,
            UikListViewBuilderProps.fromJson(wData));
      case "UikCenterRow":
        return UikCenterRow(
            WidgetType.UikCenterRow, UikCenterRowProps.fromJson(wData));
      case "UikSpacer":
        return UikSpacer(WidgetType.UikSpacer, UikSpacerProps.fromJson(wData));
      case "UikSelectFiles":
        return UikSelectFiles(
            WidgetType.UikSelectFiles, UikSelectFilesProps.fromJson(wData));
      case "UikNewReviewPage":
        return UikNewReview(
            WidgetType.UikNewReviewPage, UikNewReviewProps.fromJson(wData));

      case "UikNewRatingPage":
        return UikRating(
            WidgetType.UikNewRatingPage, UikRatingProps.fromJson(wData));

      case "UikStackImageIconPage":
        return UikStackImageIcon(WidgetType.UikStackImageIconPage,
            UikStackImageIconProps.fromJson(wData));

      case "UikReviewPage":
        return UikReview(
            WidgetType.UikReviewPage, UikReviewProps.fromJson(wData));

      case "UikSortPage":
        return UikSortPage(
            WidgetType.UikSortPage, UikSortPageProps.fromJson(wData));
      // case "UikAddress":
      //   return UikAddress(WidgetType.UikText, UikAddressProps.fromJson(wData));
      case "UikIconText":
        return UikIconText(
            WidgetType.UikIconText, UikIconTextProps.fromJson(wData));
      case "UikProfile":
        return UikProfile(
            WidgetType.UikProfile, UikProfileProps.fromJson(wData));
      case "UikTextIconButton":
        return UikTextIconButton(WidgetType.UikTextIconButton,
            UikTextIconButtonProps.fromJson(wData));
      case "UikHomeCardSeven":
        return UikHomeCardSeven(
            WidgetType.UikHomeCardSeven, UikHomeCardSevenProps.fromJson(wData));
      case "UikHomeCardTen":
        return UikHomeCardTen(
            WidgetType.UikHomeCardTen, UikHomeCardTenProps.fromJson(wData));
      case "UikHomeCardEight":
        return UikHomeCardEight(
            WidgetType.UikHomeCardEight, UikHomeCardEightProps.fromJson(wData));
      case "UikHomeCardNine":
        return UikHomeCardNine(
            WidgetType.UikHomeCardNine, UikHomeCardNineProps.fromJson(wData));
      case "UikRowText":
        return UikRowText(
            WidgetType.UikRowText, UikRowTextProps.fromJson(wData));
      case "UikTextChip":
        return UikTextChip(
            WidgetType.UikTextChip, UikTextChipProps.fromJson(wData));
      case "UikTextChipList":
        return UikTextChipList(
            WidgetType.UikTextChipList, UikTextChipListProps.fromJson(wData));
      case "UikProductImageTitlePriceCard":
        return UikProductImageTitlePriceCard(
            WidgetType.UikProductImageTitlePriceCard,
            UikProductImageTitlePriceCardProps.fromJson(wData));
      case "UikMultiButtonRow":
        return UikMultiButtonRow(WidgetType.UikMultiButtonRow,
            UikMultiButtonRowProps.fromJson(wData));
      case "UikRadioButtonList":
        return UikRadioButtonList(WidgetType.UikRadioButtonList,
            UikRadioButtonListProps.fromJson(wData));
      case "UikColumn":
        return UikColumn(WidgetType.UikColumn, UikColumnProps.fromJson(wData));
      case "UikRow":
        return UikRow(WidgetType.UikRow, UikRowProps.fromJson(wData));
      case "UikAccordion":
        return UikAccordionNew(
            WidgetType.UikAccordion, UikAccordionNewProps.fromJson(wData));
      case "UikTextDivider":
        return UikTextDivider(
            WidgetType.UikTextDivider, UikTextDividerProps.fromJson(wData));
      case "UikRowListItem":
        return UikRowListItem(
            WidgetType.UikRowListItem, UikRowListItemProps.fromJson(wData));
      case "UikDropDown":
        return UikDropDown(
            WidgetType.UikDropDown, UikDropDownProps.fromJson(wData));
      case "UikThreeColumnTile":
        return UikThreeColumnTile(WidgetType.UikThreeColumnTile,
            UikThreeColumnTileProps.fromJson(wData));
      case "UikThreeColumnTileList":
        return UikThreeColumnTileList(WidgetType.UikThreeColumnTileList,
            UikThreeColumnTileListProps.fromJson(wData));
      case "UikAnimatedImage":
        return UikAnimatedImage(
            WidgetType.UikAnimatedImage, UikAnimatedImageProps.fromJson(wData));
      case "UikThreeTextColumn":
        return UikThreeTextCard(WidgetType.UikThreeTextColumn,
            UikThreeTextCardProps.fromJson(wData));
      case "UikMyAgentReward":
        return UikMyAgentReward(
            WidgetType.UikMyAgentReward, UikMyAgentRewardProps.fromJson(wData));
      case "UikMyCustomerDetails":
        return UikMyCustomerDetails(WidgetType.UikMyCustomerDetails,
            UikMyCustomerDetailsProps.fromJson(wData));
      case "UikListItemCustomer":
        return UikListItemCustomer(WidgetType.UikListItemCustomer,
            UikListItemCustomerProps.fromJson(wData));
      case "UikHtmlRenderer":
        return UikHtmlRenderer(
            WidgetType.UikHtmlRenderer, UikHtmlRendererProps.fromJson(wData));
      case "UikAccordionNew":
        return UikAccordionNew(
            WidgetType.UikAccordionNew, UikAccordionNewProps.fromJson(wData));
      case "UikVideoPlayerNew":
        return UikVideoPlayerNew(WidgetType.UikVideoPlayerNew,
            UikVideoPlayerNewProps.fromJson(wData));
      case "UikLottieView":
        return UikLottieView(
            WidgetType.UikLottieView, UikLottieViewProps.fromJson(wData));
      case "UikLokalAcademyCard":
        return UikLokalAcademyCard(WidgetType.UikLokalAcademyCard,
            UikLokalAcademyCardProps.fromJson(wData));
      case "UikMyOrderCard":
        return UikMyOrderCard(
            WidgetType.UikMyOrderCard, UikMyOrderCardProps.fromJson(wData));
      case "UikmyAgent":
        return UikMyAgent(
            WidgetType.UikMyAgent, UikMyAgentProps.fromJson(wData));
      case "UikOrderProductCard":
        return UikOrderProductCard(
            WidgetType.UikOrderProductCard, UikOrderProductCardProps.fromJson(wData));
      default:
        return UikText(WidgetType.UikText, UikTextProps.fromJson(wData));
    }
  }

  getWidgetWithHeadersAndFooters(StandardScreenResponse standardScreenResponse,
      BuildContext context, List<UikWidget> screenWidgets) {
    late ScrollController controller = ScrollController();
    //...........................................For Headers if they are there........................//
    List<double>? stickyHeightHeaders = [];
    List<UikWidget> stickyWidgetHeaders = [];
    var preHeightHeaders = 0.0;
    //...........................................For Footers if they are there........................//
    var preHeightFooters = 0.0;
    List<double>? stickyHeightFooters = [];
    List<UikWidget> stickyWidgetFooters = [];
    if (standardScreenResponse.headers != null) {
      for (int i = 0;
          i < standardScreenResponse.headers!["items"].length;
          i++) {
        stickyHeightHeaders.add(standardScreenResponse.headers!["items"][i]
                ["height"] +
            preHeightHeaders);
        preHeightHeaders +=
            standardScreenResponse.headers!["items"][i]["height"];
        stickyWidgetHeaders.add(getWidget(
            standardScreenResponse.headers!["items"][i]["uiType"],
            standardScreenResponse.headers!["items"][i]["dataStore"]));
      }
    }
    if (standardScreenResponse.footers != null) {
      for (int i = 0;
          i < standardScreenResponse.footers!["items"].length;
          i++) {
        stickyHeightFooters.add(standardScreenResponse.footers!["items"][i]
                ["height"] +
            preHeightFooters);
        preHeightFooters +=
            standardScreenResponse.footers!["items"][i]["height"];
        stickyWidgetFooters.add(getWidget(
            standardScreenResponse.footers!["items"][i]["uiType"],
            standardScreenResponse.footers!["items"][i]["dataStore"]));
      }
    }

    var widget = StickyContainer(
      stickyChildren: [
        if (standardScreenResponse.headers != null)
          for (var i = 0;
              i < standardScreenResponse.headers!["items"].length;
              i++) ...[
            StickyWidget(
              initialPosition: StickyPosition(
                  bottom: MediaQuery.of(context).size.height -
                      stickyHeightHeaders[i],
                  right: 0),
              finalPosition: StickyPosition(
                  bottom: MediaQuery.of(context).size.height -
                      stickyHeightHeaders[i],
                  right: 0),
              controller: controller,
              child: SizedBox(
                width: MediaQuery.of(context).size.width,
                //..............................................The Sticky Widget Component............................//
                child: stickyWidgetHeaders[i],
              ),
            ),
          ],
        if (standardScreenResponse.footers != null)
          for (var i = 0;
              i < standardScreenResponse.footers!["items"].length;
              i++) ...[
            StickyWidget(
              initialPosition: StickyPosition(
                  top: MediaQuery.of(context).size.height -
                      stickyHeightFooters[i],
                  right: 0),
              finalPosition: StickyPosition(
                  top: MediaQuery.of(context).size.height -
                      stickyHeightFooters[i],
                  right: 0),
              controller: controller,
              child: SizedBox(
                width: MediaQuery.of(context).size.width,
                //..............................................The Sticky Widget Component............................//
                child: stickyWidgetFooters[i],
              ),
            ),
          ],
      ],
      child: Container(
        margin:
            EdgeInsets.only(top: preHeightHeaders, bottom: preHeightFooters),
        child: ListView.builder(
          controller: controller,
          itemCount: screenWidgets.length,
          itemBuilder: (BuildContext ctx, int index) {
            return Align(
              child: screenWidgets[index],
            );
          },
        ),
      ),
    );
    return widget;
  }

  getListWidgetUi(StandardScreenResponse standardScreenResponse,
      BuildContext context) {
    int length = standardScreenResponse.widgets.length ?? 2;
    List<UikWidget> screenWidgets = [];

    for (int widgetIndex = 0; widgetIndex < length; widgetIndex++) {
      StandardPageResponseWidgets widgetData =
          standardScreenResponse.widgets[widgetIndex];
      dynamic widgetDataStore =
          standardScreenResponse.dataStore![widgetData.id];
      if (widgetDataStore != null) {
        UikWidget widget = getWidget(widgetData.uiType, widgetDataStore);
        screenWidgets.add(widget);
      }
    }

    if (standardScreenResponse.headers != null ||
        standardScreenResponse.footers != null) {
      //........................................Response Having Sticky Components(headers or footers)......................................//
      return getWidgetWithHeadersAndFooters(
          standardScreenResponse, context, screenWidgets);
    } else {
      //........................................Response Having No Sticky Components(headers or footers)......................................//
      var widget = ListView.builder(
        itemCount: screenWidgets.length,
        itemBuilder: (BuildContext ctx, int index) {
          return Align(
            child: screenWidgets[index],
          );
        },
      );
      return widget;
    }
  }
}
