// // dog_card.dart

import 'package:flutter/material.dart';
import 'package:just_the_tooltip/just_the_tooltip.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';

import '../props/UikToolTipProps.dart';

class UikToolTip extends UikWidget {
  WidgetType _widgetType;
  UikToolTipProps _UikToolTipProps;
  UikToolTip(this._widgetType, this._UikToolTipProps)
      : super(_widgetType, _UikToolTipProps);

  @override
  _UikToolTipState createState() => _UikToolTipState(_UikToolTipProps);
}

String callForLoop(List<dynamic> ll) {
  String toReturn = "";
  for (int i = 0; i < ll.length - 1; i++) {
    String s = ll[i];
    toReturn = toReturn + s + "\n";
  }
  toReturn = toReturn + ll[ll.length - 1];

  return toReturn;
}

double callWidthForLoop(List<dynamic> ll) {
  double toReturn = 0;
  for (int i = 0; i < ll.length - 1; i++) {
    if (toReturn < ll[i].length) toReturn = ll[i].length;
  }
  // toReturn = toReturn + ll[ll.length - 1];
  toReturn = toReturn * 7;

  return toReturn;
}

class _UikToolTipState extends State<UikToolTip> {
  UikToolTipProps _UikToolTipProps;
  _UikToolTipState(this._UikToolTipProps);

  var Cheight = 60.0;
  var CWidth = 40.0;
  var textColor;
  var direction;

  @override
  Widget build(BuildContext context) {
    String toPrint = callForLoop(_UikToolTipProps.ll);
    Cheight += (10 * (_UikToolTipProps.ll.length));
    CWidth += callWidthForLoop(_UikToolTipProps.ll);
    if (_UikToolTipProps.direction == "up") direction = AxisDirection.up;
    if (_UikToolTipProps.direction == "down") direction = AxisDirection.down;
    if (_UikToolTipProps.direction == "right") direction = AxisDirection.right;
    if (_UikToolTipProps.direction == "left") direction = AxisDirection.left;

    var Elevation = 4.0;
    if (_UikToolTipProps.NoBackground == true) {
      textColor = Colors.white;
      Elevation = 0.0;
    }
    if (_UikToolTipProps.NoBackground == false) textColor = Colors.yellow;
    return JustTheTooltip(
      tailLength: 7,
      backgroundColor: textColor,
      borderRadius: BorderRadius.all(Radius.circular(5)),
      tailBaseWidth: 12,
      preferredDirection: direction,
      elevation: Elevation,
      child: Container(
        width: _UikToolTipProps.childwidth,
        height: _UikToolTipProps.childheight,
        child: _UikToolTipProps.child,
      ),
      content: Container(
        width: CWidth,
        height: Cheight,
        decoration: BoxDecoration(
          borderRadius: BorderRadius.circular(7),
          border: Border.all(color: textColor, width: 1.0),
        ),
        child: Column(
          children: [
            if (_UikToolTipProps.bulletPoint) ...[
              Container(
                padding: EdgeInsets.fromLTRB(10, 10, 0, 5),
                alignment: Alignment.topLeft,
                child: Text(
                  "ToolTip",
                  style: TextStyle(
                    fontSize: 12,
                    fontWeight: FontWeight.w600,
                    color: _UikToolTipProps.NoBackground == false
                        ? Colors.black
                        : Color(0xFF9E9E9E),
                  ),
                ),
              ),
              for (int i = 0; i < _UikToolTipProps.ll.length; i++) ...[
                Row(
                  children: [
                    SizedBox(
                      width: 10.8,
                    ),
                    Container(
                      height: 10.4,
                      width: 10.4,
                      decoration: new BoxDecoration(
                        color: _UikToolTipProps.NoBackground == false
                            ? Colors.black
                            : Color(0xFF9E9E9E),
                        shape: BoxShape.circle,
                      ),
                    ),
                    SizedBox(
                      width: 10.8,
                    ),
                    Flexible(
                      // width: 42,
                      // height: 15,
                      child: Text(
                        _UikToolTipProps.ll[i],
                        style: TextStyle(
                          color: _UikToolTipProps.NoBackground == false
                              ? Colors.black
                              : Color(0xFF9E9E9E),
                        ),
                      ),
                    ),
                    SizedBox(
                      height: 10,
                    ),
                  ],
                ),
              ],
            ],
            if (_UikToolTipProps.bulletPoint == false) ...[
              for (int i = 0; i < _UikToolTipProps.ll.length; i++) ...[
                Container(
                  child: Text(
                    _UikToolTipProps.ll[i],
                    style: TextStyle(
                      color: _UikToolTipProps.NoBackground == false
                          ? Colors.black
                          : Color(0xFF9E9E9E),
                    ),
                  ),
                ),
                SizedBox(
                  height: 5,
                )
              ],
            ],
          ],
        ),
      ),
    );
    // );
  }
}
