import 'package:accordion/accordion.dart';
import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';

import '../props/UikAccordionNewProps.dart';

class UikAccordionNew extends UikWidget {
  WidgetType _widgetType;
  UikAccordionNewProps _UikAccordionNewProps;
  UikAccordionNew(this._widgetType, this._UikAccordionNewProps)
      : super(_widgetType, _UikAccordionNewProps);

  @override
  _UikAccordionNewState createState() => _UikAccordionNewState(_UikAccordionNewProps);
}

class _UikAccordionNewState extends State<UikAccordionNew> {
  final UikAccordionNewProps _UikAccordionNewProps;
  _UikAccordionNewState(this._UikAccordionNewProps);

  @override
  Widget build(BuildContext context) {
    return Accordion(
      paddingListBottom: _UikAccordionNewProps.paddingListBottom,
      flipRightIconIfOpen: _UikAccordionNewProps.flipRightIconIfOpen,
      disableScrolling: _UikAccordionNewProps.disableScrolling,
      children: [
        AccordionSection(
          rightIcon: _UikAccordionNewProps.rightComponent,
          header: _UikAccordionNewProps.headerComponent,
          content: _UikAccordionNewProps.contentComponent,
          headerBackgroundColor: _UikAccordionNewProps.headerBackgroundColor
              .withOpacity(_UikAccordionNewProps.opacity),
          contentBackgroundColor: _UikAccordionNewProps.contentBackgroundColor
              .withOpacity(_UikAccordionNewProps.opacity),
          contentBorderColor: _UikAccordionNewProps.contentBorderColor
              .withOpacity(_UikAccordionNewProps.opacity),
          headerPadding: _UikAccordionNewProps.headerPadding,
          headerBorderRadius: _UikAccordionNewProps.headerBorderRadius,
            paddingBetweenClosedSections: _UikAccordionNewProps.paddingBetweenClosedSections,
        ),
      ],
    );
  }
}
