import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';

import '../props/UikColumnProps.dart';

class UikColumn extends UikWidget {
  WidgetType _widgetType;
  UikColumnProps _UikColumnProps;
  UikColumn(this._widgetType, this._UikColumnProps)
      : super(_widgetType, _UikColumnProps);
  @override
  _UikColumnState createState() => _UikColumnState(_UikColumnProps);
}

class _UikColumnState extends State<UikColumn> {
  UikColumnProps _uikColumnProps;
  _UikColumnState(this._uikColumnProps);

  @override
  Widget build(BuildContext context) {
    return Container(
      height: _uikColumnProps.height,
      padding: EdgeInsets.fromLTRB(
        1,
        _uikColumnProps.topMargin,
        _uikColumnProps.rightMargin,
        _uikColumnProps.bottomMargin,
      ),
      child: SingleChildScrollView(
        physics: const BouncingScrollPhysics(),
        scrollDirection: Axis.vertical,
        child: Column(
          mainAxisAlignment: MainAxisAlignment.start,
          children: _uikColumnProps.widgets,
        ),
      ),
    );
  }
}
