import "package:flutter/material.dart";
import 'package:ui_sdk/components/WidgetType.dart';

import '../props/UikDividerProps.dart';
import 'UikWidget.dart';

class UikDivider extends UikWidget {
  WidgetType _widgetType;
  UikDividerProps _uikDividerProps;
  UikDivider(this._widgetType, this._uikDividerProps)
      : super(_widgetType, _uikDividerProps);

  @override
  _UikDividerState createState() => _UikDividerState(_uikDividerProps);
}

class _UikDividerState extends State<UikDivider> {
  UikDividerProps _uikDividerProps;
  _UikDividerState(this._uikDividerProps);

  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        if (_uikDividerProps.dividerSize == "large") ...[
          Container(
            width: _uikDividerProps.widthSize,
            height: 3,
            decoration: BoxDecoration(
                color: _uikDividerProps.dividerColor,
                border: Border.all(
                  color: _uikDividerProps.dividerColor,
                ),
                borderRadius: (_uikDividerProps.corner == "rounded")
                    ? BorderRadius.circular(10)
                    : BorderRadius.circular(0)),
          ),
        ] else if (_uikDividerProps.dividerSize == "medium") ...[
          Container(
            width: _uikDividerProps.widthSize,
            height: 2,
            decoration: BoxDecoration(
                color: _uikDividerProps.dividerColor,
                border: Border.all(
                  color: _uikDividerProps.dividerColor,
                ),
                borderRadius: (_uikDividerProps.corner == "rounded")
                    ? BorderRadius.circular(10)
                    : BorderRadius.circular(0)),
          ),
        ] else ...[
          Container(
            width: _uikDividerProps.widthSize,
            height: 1,
            decoration: BoxDecoration(
                color: _uikDividerProps.dividerColor,
                border: Border.all(
                  color: _uikDividerProps.dividerColor,
                ),
                borderRadius: (_uikDividerProps.corner == "rounded")
                    ? BorderRadius.circular(10)
                    : BorderRadius.circular(0)),
          ),
        ]
      ],
    );
  }
}
