import "package:flutter/material.dart";
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/utils/UikActionListner.dart';

import '../props/UikDropDownProps.dart';
import 'UikWidget.dart';

class UikDropDown extends UikWidget {
  WidgetType _widgetType;
  UikDropDownProps _uikDropDownProps;
  UikDropDown(this._widgetType, this._uikDropDownProps)
      : super(_widgetType, _uikDropDownProps);

  @override
  _UikDropDownState createState() => _UikDropDownState(_uikDropDownProps);
}

class _UikDropDownState extends State<UikDropDown> {
  UikDropDownProps _uikDropDownProps;
  _UikDropDownState(this._uikDropDownProps);

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () async {
        print("Hello I am UikAction");
        await executeUikWidgetAction(_uikDropDownProps.action);
      },
      child: Container(
        height: _uikDropDownProps.height,
        width: _uikDropDownProps.width,
        margin: EdgeInsets.only(
          left: _uikDropDownProps.leftMargin,
          right: _uikDropDownProps.rightMargin,
          top: _uikDropDownProps.topMargin,
          bottom: _uikDropDownProps.bottomMargin,
        ),
        padding: const EdgeInsets.symmetric(
          vertical: 20.0,
          horizontal: 16.0,
        ),
        decoration: BoxDecoration(
          borderRadius: BorderRadius.circular(8.0),
          color: const Color(0xFFF5F5F5),
        ),
        child: Row(
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          children: [
            Text(
              _uikDropDownProps.text,
              style: const TextStyle(
                fontSize: 16.0,
                color: Color(0xFF9E9E9E),
              ),
            ),
            const Icon(
              Icons.keyboard_arrow_down_rounded,
              color: Color(0xFF9E9E9E),
            ),
          ],
        ),
      ),
    );
  }
}
