import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';

import '../props/UikListItemsProps.dart';

class UikListItems extends UikWidget {
  WidgetType _widgetType;
  UikListItemsProps _uikListItemsProps;
  UikListItems(this._widgetType, this._uikListItemsProps)
      : super(_widgetType, _uikListItemsProps);

  @override
  _UikListItemsState createState() => _UikListItemsState(_uikListItemsProps);
}

class _UikListItemsState extends State<UikListItems> {
  UikListItemsProps _uikListItemsProps;
  _UikListItemsState(this._uikListItemsProps);
  var index = -1;

  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        Container(
          //color: Colors.white,
          width: _uikListItemsProps.width,
          height: _uikListItemsProps.list.length * _uikListItemsProps.height,
          // decoration: BoxDecoration(border: Border.all(width: 3)),
          child: ListView(
            children: <Widget>[
              for (int i = 0; i < _uikListItemsProps.list.length; i++) ...[
                MouseRegion(
                  onHover: (PointerHoverEvent event) {
                    //  print(event.position);
                    setState(() {
                      index = i;
                    });
                  },
                  onExit: (PointerExitEvent event) {
                    setState(() {
                      index = -1;
                    });
                  },
                  child: Container(
                    height: _uikListItemsProps.height,
                    // decoration: BoxDecoration(
                    //   border: Border.all(width: 3),
                    // ),
                    child: ListTile(
                      leading: (_uikListItemsProps.bullet.isNotEmpty)
                          ? Container(
                              height: 12.0,
                              width: 12.0,
                              decoration: BoxDecoration(
                                color:
                                    (i == index) ? Colors.blue : Colors.black,
                                shape: BoxShape.circle,
                              ),
                            )
                          : (_uikListItemsProps.iconList[i] != null)
                              ? _uikListItemsProps.iconList[i]
                              : null,
                      title: Text(
                        _uikListItemsProps.list[i],
                        style: const TextStyle(fontSize: 15),
                      ),
                      textColor: (i == index) ? Colors.blue : Colors.black,
                      onTap: () {},
                    ),
                  ),
                )
              ]
            ],
          ),
        ),
      ],
    );
  }
}
