import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';

import '../props/UikListTileProps.dart';
import '../utils/UikActionListner.dart';

class UikListTile extends UikWidget {
  WidgetType _widgetType;
  UikListTileProps _uikListTileProps;

  UikListTile(this._widgetType, this._uikListTileProps)
      : super(_widgetType, _uikListTileProps);

  @override
  _UikListTileState createState() => _UikListTileState(_uikListTileProps);
}

class _UikListTileState extends State<UikListTile> {
  UikListTileProps _uikListTileProps;

  _UikListTileState(this._uikListTileProps);

  @override
  Widget build(BuildContext context) {
    return Container(
      margin: EdgeInsets.fromLTRB(
          _uikListTileProps.leftMargin,
          _uikListTileProps.topMargin,
          _uikListTileProps.rightMargin,
          _uikListTileProps.bottomMargin),
      decoration: BoxDecoration(
          gradient: _uikListTileProps.isGradient
              ? LinearGradient(
            begin: Alignment.topCenter,
                  end: Alignment.bottomCenter,
                  colors: _uikListTileProps.gradientColors!,
                )
              : null),
      child: ListTile(
        onTap: () async {
          await executeUikWidgetAction(_uikListTileProps.action);
        },
        leading: _uikListTileProps.leading,
        title: _uikListTileProps.title,
        subtitle: _uikListTileProps.subtitle,
        trailing: _uikListTileProps.trailing,
      ),
    );
  }
}
