import "package:flutter/material.dart";
import 'package:ui_sdk/components/WidgetType.dart';

import '../props/UikMembershipProps.dart';
import 'UikWidget.dart';

class UikMembership extends UikWidget {
  WidgetType _widgetType;
  UikMembershipProps _uikMembershipProps;
  UikMembership(this._widgetType, this._uikMembershipProps)
      : super(_widgetType, _uikMembershipProps);

  @override
  _UikMembershipState createState() => _UikMembershipState(_uikMembershipProps);
}

class _UikMembershipState extends State<UikMembership> {
  UikMembershipProps _uikMembershipProps;
  _UikMembershipState(this._uikMembershipProps);

  @override
  Widget build(BuildContext context) {
    return Column(
      crossAxisAlignment: CrossAxisAlignment.start,
      children: [
        Container(
          margin: EdgeInsets.only(top: 40,left: 16),
          width: 337,
          height: 395,
          decoration: BoxDecoration(
            color: Color(0xFFFFFFFF),
            borderRadius: BorderRadius.circular(8),
            border: Border.all(
              color: Color(0xFFFFC107),
            ),
          ),
          child: Column(
            children: [
              Container(
                width: 337,
                height: 192.38,
                decoration: const BoxDecoration(
                  color: Color(
                    0xFFFFC107,
                  ),
                  borderRadius: BorderRadius.only(
                    topRight: Radius.circular(8),
                    topLeft: Radius.circular(8),
                  ),
                ),
                //color: Color(0xFFFFC107),
                padding: EdgeInsets.fromLTRB(27.0, 24.0, 0, 0),
                child: Column(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: [
                    Text(
                      _uikMembershipProps.headingText,
                      style: const TextStyle(
                        fontSize: 24,
                        fontWeight: FontWeight.bold,
                      ),
                    ),
                    const SizedBox(
                      height: 4,
                    ),
                    Text(
                      _uikMembershipProps.subtitleText,
                      style: TextStyle(fontSize: 18, fontWeight: FontWeight.w500),
                    ),
                    SizedBox(
                      height: 52,
                    ),
                    Row(
                      mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                      children: [
                        const Text(
                          "₹ ",
                          style: TextStyle(
                            fontSize: 24,
                            fontWeight: FontWeight.bold,
                          ),
                        ),
                        Text(
                          _uikMembershipProps.price.toString(),
                          style:
                              TextStyle(fontSize: 32, fontWeight: FontWeight.bold),
                        ),
                        Text(
                          "/" + _uikMembershipProps.duration,
                          style: TextStyle(fontSize: 18),
                        ),
                        SizedBox(
                          width: 50,
                        ),
                        Container(margin: EdgeInsets.only(right: 17.62),child: _uikMembershipProps.button,)
                      ],
                    ),
                  ],
                ),
              ),
              Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  Container(
                    width: 337,
                    height: 140,
                    // color: Colors.grey,
                    padding: EdgeInsets.fromLTRB(25.07, 31, 0, 0),
                    child: ListView(
                      children: [
                        for (int i = 0; i < 3; i++) ...[
                          Row(
                            children: [
                              Container(child: _uikMembershipProps.icon,),
                              SizedBox(
                                width: 16.07,
                              ),
                              Text(_uikMembershipProps.perks[i]),
                            ],
                          ),
                          const SizedBox(
                            height: 15,
                          ),
                        ],
                      ],
                    ),
                  ),
                  Container(
                    padding: EdgeInsets.only(left: 45),
                    child: _uikMembershipProps.button2,
                  ),
                ],
              ),
            ],
          ),
        ),
      ],
    );
  }
}
