import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikImage.dart';
import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';

import '../props/UikMyAgentRewardProps.dart';

class UikMyAgentReward extends UikWidget {
  WidgetType _widgetType;
  UikMyAgentRewardProps _UikMyAgentRewardProps;

  UikMyAgentReward(this._widgetType, this._UikMyAgentRewardProps)
      : super(_widgetType, _UikMyAgentRewardProps);

  @override
  _UikMyAgentRewardState createState() =>
      _UikMyAgentRewardState(_UikMyAgentRewardProps);
}

class _UikMyAgentRewardState extends State<UikMyAgentReward> {
  UikMyAgentRewardProps _UikMyAgentRewardProps;
  _UikMyAgentRewardState(this._UikMyAgentRewardProps);

  @override
  Widget build(BuildContext context) {
    return ClipRRect(
      borderRadius: BorderRadius.circular(25),
      child: Container(
      color: Color(0xFFF9F0E9),
      height: _UikMyAgentRewardProps.height,
      width: _UikMyAgentRewardProps.width,
      child: Column(
        children: [
          Padding(
            padding: EdgeInsets.only(left: 14, top: 16),
            child: Row(
              children: [
                UikImage(
                    WidgetType.UikImage, _UikMyAgentRewardProps.imageProps),
                Column(
                  children: [
                    UikText(
                        WidgetType.UikText, _UikMyAgentRewardProps.amountProps),
                    UikText(
                        WidgetType.UikText, _UikMyAgentRewardProps.text1Props),
                  ],
                ),
                const SizedBox(width: 90,),
                UikImage(
                    WidgetType.UikImage, _UikMyAgentRewardProps.circleIconProps),
              ],
            ),
          ),
          const SizedBox(height: 25,),
          Padding(
            padding: EdgeInsets.only(left: 30),
            child: Column(
              children: [
                Row(
                  children: [
                    UikImage(
                        WidgetType.UikIcon, _UikMyAgentRewardProps.dot1Props),
                    const SizedBox(
                      width: 5,
                    ),
                    UikText(
                        WidgetType.UikText, _UikMyAgentRewardProps.num1Props),
                    const SizedBox(
                      width: 130,
                    ),
                    UikImage(
                        WidgetType.UikIcon, _UikMyAgentRewardProps.dot2Props),
                    const SizedBox(
                      width: 5,
                    ),
                    UikText(
                        WidgetType.UikText, _UikMyAgentRewardProps.num2Props),
                  ],
                ),
                Row(
                  children: [
                    UikText(
                        WidgetType.UikText, _UikMyAgentRewardProps.text2Props),
                    const SizedBox(
                      width: 130,
                    ),
                    UikText(
                        WidgetType.UikText, _UikMyAgentRewardProps.text3Props),
                  ],
                )
              ],
            ),
          ),
        ],
      ),
    )
    );
  }
}
