// ignore_for_file: prefer_final_fields, no_logic_in_create_state
import "package:flutter/material.dart";
import 'package:google_fonts/google_fonts.dart';
import 'package:ui_sdk/components/UikImage.dart';
import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/components/WidgetType.dart';

import '../props/UikMyCustomerDetailsProps.dart';
import 'UikWidget.dart';

// ignore: must_be_immutable
class UikMyCustomerDetails extends UikWidget {
  // ignore: unused_field
  WidgetType _widgetType;
  UikMyCustomerDetailsProps _uikMyCustomerDetailsProps;
  UikMyCustomerDetails(this._widgetType, this._uikMyCustomerDetailsProps)
      : super(_widgetType, _uikMyCustomerDetailsProps);

  @override
  _UikMyCustomerDetailsState createState() =>
      _UikMyCustomerDetailsState(_uikMyCustomerDetailsProps);
}

class _UikMyCustomerDetailsState extends State<UikMyCustomerDetails> {
  UikMyCustomerDetailsProps _uikMyCustomerDetailsProps;
  _UikMyCustomerDetailsState(this._uikMyCustomerDetailsProps);

  @override
  Widget build(BuildContext context) {
    return Column(
      crossAxisAlignment: CrossAxisAlignment.start,
      children: [
        const SizedBox(
          height: 25,
        ),
        Padding(
          padding: const EdgeInsets.only(
            left: 10,
          ),
          child: Row(
            children: [
              UikImage(WidgetType.UikImage, _uikMyCustomerDetailsProps.image),
              const SizedBox(
                width: 225,
              ),
              UikText(WidgetType.UikText, _uikMyCustomerDetailsProps.date),
            ],
          ),
        ),
        const SizedBox(
          height: 35,
        ),
        Padding(
            padding: const EdgeInsets.only(left: 22),
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [
                Text(
                  "Full Name",
                  style: GoogleFonts.poppins(
                    fontSize: 14,
                    fontWeight: FontWeight.w400,
                    color: const Color(0xFF9E9E9E),
                  ),
                ),
                UikText(WidgetType.UikText, _uikMyCustomerDetailsProps.name),
                const SizedBox(
                  height: 16,
                ),
                Text(
                  "Mobile",
                  style: GoogleFonts.poppins(
                    fontSize: 14,
                    fontWeight: FontWeight.w400,
                    color: const Color(0xFF9E9E9E),
                  ),
                ),
                UikText(WidgetType.UikText, _uikMyCustomerDetailsProps.phone),
                const SizedBox(
                  height: 16,
                ),
                Text(
                  "Email",
                  style: GoogleFonts.poppins(
                    fontSize: 14,
                    fontWeight: FontWeight.w400,
                    color: const Color(0xFF9E9E9E),
                  ),
                ),
                UikText(WidgetType.UikText, _uikMyCustomerDetailsProps.email),
                const SizedBox(
                  height: 16,
                ),
                Text(
                  "Age",
                  style: GoogleFonts.poppins(
                    fontSize: 14,
                    fontWeight: FontWeight.w400,
                    color: const Color(0xFF9E9E9E),
                  ),
                ),
                UikText(WidgetType.UikText, _uikMyCustomerDetailsProps.age),
                const SizedBox(
                  height: 16,
                ),
                Text(
                  "State",
                  style: GoogleFonts.poppins(
                    fontSize: 14,
                    fontWeight: FontWeight.w400,
                    color: const Color(0xFF9E9E9E),
                  ),
                ),
                UikText(WidgetType.UikText, _uikMyCustomerDetailsProps.state),
                const SizedBox(
                  height: 16,
                ),
                Text(
                  "District",
                  style: GoogleFonts.poppins(
                    fontSize: 14,
                    fontWeight: FontWeight.w400,
                    color: const Color(0xFF9E9E9E),
                  ),
                ),
                UikText(
                    WidgetType.UikText, _uikMyCustomerDetailsProps.district),
                const SizedBox(
                  height: 16,
                ),
                Text(
                  "Block",
                  style: GoogleFonts.poppins(
                    fontSize: 14,
                    fontWeight: FontWeight.w400,
                    color: const Color(0xFF9E9E9E),
                  ),
                ),
                UikText(WidgetType.UikText, _uikMyCustomerDetailsProps.block),
                const SizedBox(
                  height: 16,
                ),
                Text(
                  "Pincode",
                  style: GoogleFonts.poppins(
                    fontSize: 14,
                    fontWeight: FontWeight.w400,
                    color: const Color(0xFF9E9E9E),
                  ),
                ),
                UikText(WidgetType.UikText, _uikMyCustomerDetailsProps.pincode),
                const SizedBox(
                  height: 16,
                ),
                Text(
                  "Employment",
                  style: GoogleFonts.poppins(
                    fontSize: 14,
                    fontWeight: FontWeight.w400,
                    color: const Color(0xFF9E9E9E),
                  ),
                ),
                UikText(
                    WidgetType.UikText, _uikMyCustomerDetailsProps.employment),
                const SizedBox(
                  height: 16,
                ),
              ],
            )),
      ],
    );
  }
}
