// import 'package:digia_vdl/components/UikWidget.dart';
// import 'package:digia_vdl/components/WidgetType.dart';
// import 'package:digia_vdl/props/UikOrderAgainProductProps.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';

import '../props/UikOrderAgainProductProps.dart';
import 'UikWidget.dart';
import 'WidgetType.dart';

class UikOrderAgainProduct extends UikWidget {
  WidgetType _widgetType;
  UikOrderAgainProductProps _UikOrderAgainProductProps;
  UikOrderAgainProduct(this._widgetType, this._UikOrderAgainProductProps)
      : super(_widgetType, _UikOrderAgainProductProps);

  @override
  _UikOrderAgainProductState createState() =>
      _UikOrderAgainProductState(_UikOrderAgainProductProps);
}

class _UikOrderAgainProductState extends State<UikOrderAgainProduct> {
  UikOrderAgainProductProps _UikOrderAgainProductProps;
  _UikOrderAgainProductState(this._UikOrderAgainProductProps);

  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        Stack(
          children: [
            Container(
              width: 153,
              height: 57,
              decoration: BoxDecoration(
                borderRadius: BorderRadius.circular(5),
                color: const Color(0xffFFFFFF),
                // color: Colors.amber,
              ),
            ),
            //............................................Item Description....................................//
            Positioned(
              top: 4,
              left: 64,
              child: Container(
                width: 84,
                height: 21,
                child: Text(
                  _UikOrderAgainProductProps.itemDes,
                  style: GoogleFonts.poppins(
                    fontWeight: FontWeight.w500,
                    fontSize: 14,
                    color: const Color(0xff212121),
                  ),
                ),
              ),
            ),

            //............................................Item Price..........................................//
            Positioned(
              top: 25,
              left: 64,
              child: Container(
                width: 84,
                height: 21,
                child: Text(
                  "\$${_UikOrderAgainProductProps.itemPrice.toStringAsFixed(2)}",
                  style: GoogleFonts.poppins(
                    fontWeight: FontWeight.w500,
                    fontSize: 12,
                    color: const Color(0xff212121),
                  ),
                ),
              ),
            ),
            //................................................Stars.........................................//
            Positioned(
              top: 41.83,
              left: 64.62,
              child: Row(
                children: [
                  for (int i = 0; i < 5; i++) ...[
                    // const UikIcon(
                    //   valIcon: Icons.star,
                    //   iconSize: 9,
                    //   iconColor: Color(0xffFEE440),
                    // ),
                    //
                    // Icon(Icons.star),
                    _UikOrderAgainProductProps.starIcon,
                    const SizedBox(
                      width: 3.75,
                    ),
                  ],
                ],
              ),
            ),

            //...........................................Image.........................................//
            Positioned(
              // top: 41.83,
              // left: 64.62,
              right: 99,
              child: Container(
                width: 54,
                height: 57,
                decoration: BoxDecoration(
                  image: DecorationImage(
                    image: NetworkImage(
                      _UikOrderAgainProductProps.imgUrl,
                    ),
                    fit: BoxFit.fill,
                  ),
                  borderRadius: BorderRadius.circular(5),
                ),
              ),
              // Image(image: Image.asset("assets/orderAgainProduct")),
            ),
          ],
        ),
      ],
    );
  }
}
