// dog_card.dart

// import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';

import '../props/UikProductProps.dart';

class UikProduct extends UikWidget {
  WidgetType _widgetType;
  UikProductProps _UikProductProps;
  UikProduct(this._widgetType, this._UikProductProps)
      : super(_widgetType, _UikProductProps);

  @override
  _UikProductState createState() => _UikProductState(_UikProductProps);
}

class _UikProductState extends State<UikProduct> {
  UikProductProps _UikProductProps;
  _UikProductState(this._UikProductProps);

  @override
  Widget build(BuildContext context) {
    return Stack(
      children: [
        Container(
          decoration: BoxDecoration(
              image: DecorationImage(
                  fit: BoxFit.cover,
                  image: NetworkImage(
                   _UikProductProps.imgUrl,
                  ),
                ),
              borderRadius: BorderRadius.circular(10)),
          width: 252,
          height: 142,
          // color: Colors.green,
          // child: UikImage(
          //   valImage: Image.asset("assets/product.png").image,
          //   // iFit: BoxFit.fill,
          //   iHeight: 400.0,
          //   iWidth: 400.0,
          //   // imgColor: Colors.red,
          // ),
        ),
        Positioned(
          top: 61,
          left: 13,
          right: 178,
          bottom: 57,
          child: Container(
            width: 61,
            height: 24,
            child: Text(
              _UikProductProps.imgPrice,
              style: GoogleFonts.poppins(
                  fontSize: 16,
                  fontWeight: FontWeight.w600,
                  color: Color(0xFFFFFFFF)),
            ),
          ),
        ),
        Positioned(
          top: 87,
          left: 13,
          // right: 54,
          // bottom: 18,
          child: Container(
            width: 185,
            height: 40,
            child: Text(
              // "Wooden bedside table featuring a raised design",
              _UikProductProps.imgDescription,
              style: GoogleFonts.poppins(
                  fontSize: 14,
                  fontWeight: FontWeight.w500,
                  color: Color(0xFFFFFFFF)),
            ),
          ),
        ),
        Positioned(
          top: 97,
          left: 205,
          child: Container(
            width: 35,
            height: 20,
            decoration: BoxDecoration(
              borderRadius: BorderRadius.circular(5),
              color: Color(0xFFFFCA28),
            ),
            child: Row(
              children: [
                Container(
                  // width: 19,
                  // height: 24,
                  // margin: EdgeInsets.fromLTRB(3, 2, 2, 3),
                  margin: EdgeInsets.only(left: 3, right: 2),
                  child: Text(
                    "${_UikProductProps.imgRating.toStringAsFixed(1)}",
                    style: GoogleFonts.poppins(
                        fontSize: 12,
                        fontWeight: FontWeight.w500,
                        color: Color(0xFF212121)),
                  ),
                ),

                _UikProductProps.starIcon,
                // Container(
                //   // width: 8,
                //   // height: 8,
                //   // margin: EdgeInsets.only(top: 6, bottom: 3),
                //   child: _UikProductProps.starIcon,
                //   // UikIcon(
                //   //   valIcon: Icons.star,
                //   //   iconSize: 8.0,
                //   //   iconColor: Color(0xFF212121),
                //   // ),
                // ),
              ],
            ),
          ),
        ),
        Positioned(
          top: 11,
          left: 212,
          // right: 12,
          // bottom: 23,
          child: Container(
            width: 28,
            height: 28,
            decoration: BoxDecoration(
              borderRadius: BorderRadius.circular(30),
              color: Color(0xFFFFFFFF),
            ),
            child: _UikProductProps.heartIcon,
            // UikIcon(
            //   valIcon: Icons.favorite_border_outlined,
            //   iconSize: 12.0,
            //   // iconColor: Color(0xFF212121),
            // ),
          ),
        ),
      ],
    );
  }
}
