import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';

import '../props/UikRadioButtonProps.dart';

class UikRadioButton extends UikWidget {
  WidgetType _widgetType;
  UikRadioButtonProps _uikRadioButtonProps;
  UikRadioButton(this._widgetType, this._uikRadioButtonProps)
      : super(_widgetType, _uikRadioButtonProps);

  @override
  _UikRadioButtonState createState() =>
      _UikRadioButtonState(_uikRadioButtonProps);
}

class _UikRadioButtonState extends State<UikRadioButton> {
  UikRadioButtonProps _uikRadioButtonProps;
  _UikRadioButtonState(this._uikRadioButtonProps);

  int check = 0;

  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        GestureDetector(
          child: Container(
            width: 24,
            height: 24,
            // color: Colors.grey,
            // padding: EdgeInsets.symmetric(horizontal: 12, vertical: 8),
            decoration: BoxDecoration(
              color: (check == 1)
                  ? ((_uikRadioButtonProps.state == "enabled")
                      ? Colors.yellow.withOpacity(0.4)
                      : Colors.yellow)
                  : (Color(0xFFF5F5F5)),
              borderRadius:
                  BorderRadius.circular(_uikRadioButtonProps.borderRadius),
              border: Border.all(
                color: Colors.white,
                width: 1,
              ),
            ),
            child: (check == 1)
                ? Icon(
                    Icons.check_outlined,
                    size: 15.0,
                    color: (_uikRadioButtonProps.state == "enabled")
                        ? Colors.black.withOpacity(0.2)
                        : Colors.black,
                  )
                : null,
          ),
          onTap: () => {
            //   print(transparent),
            setState(() {
              if (check == 0) {
                check = 1;
              } else {
                check = 0;
              }
            }),
          },
        ),
      ],
    );
  }
}
