import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';

import '../props/UikScreenTitleSubtitleProps.dart';

class UikScreenTitleSubtitle extends UikWidget {
  WidgetType _widgetType;
  UikScreenTitleSubtitleProps _uikScreenTitleSubtitleProps;
  UikScreenTitleSubtitle(this._widgetType, this._uikScreenTitleSubtitleProps)
      : super(_widgetType, _uikScreenTitleSubtitleProps);

  @override
  _UikScreenTitleSubtitleState createState() =>
      _UikScreenTitleSubtitleState(_uikScreenTitleSubtitleProps);
}

class _UikScreenTitleSubtitleState extends State<UikScreenTitleSubtitle> {
  UikScreenTitleSubtitleProps _uikScreenTitleSubtitleProps;
  _UikScreenTitleSubtitleState(this._uikScreenTitleSubtitleProps);

  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: EdgeInsets.only(
        left: _uikScreenTitleSubtitleProps.leftPadding,
        right: _uikScreenTitleSubtitleProps.rightPadding,
        top: _uikScreenTitleSubtitleProps.topPadding,
        bottom: _uikScreenTitleSubtitleProps.bottomPadding,
      ),
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          _uikScreenTitleSubtitleProps.title,
          const SizedBox(height: 6.0),
          if (_uikScreenTitleSubtitleProps.subtitle != null)
            _uikScreenTitleSubtitleProps.subtitle!,
        ],
      ),
    );
  }
}
