import 'package:dotted_border/dotted_border.dart';
import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';

import '../props/UikSelectFilesProps.dart';

class UikSelectFiles extends UikWidget {
  WidgetType _widgetType;
  UikSelectFilesProps _uikSelectFilesProps;
  UikSelectFiles(this._widgetType, this._uikSelectFilesProps)
      : super(_widgetType, _uikSelectFilesProps);

  @override
  _UikSelectFilesState createState() =>
      _UikSelectFilesState(_uikSelectFilesProps);
}

class _UikSelectFilesState extends State<UikSelectFiles> {
  UikSelectFilesProps _uikSelectFilesProps;
  _UikSelectFilesState(this._uikSelectFilesProps);

  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: EdgeInsets.only(
        left: _uikSelectFilesProps.leftMargin,
        right: _uikSelectFilesProps.rightMargin,
        top: _uikSelectFilesProps.topMargin,
        bottom: _uikSelectFilesProps.bottomMargin,
      ),
      child: DottedBorder(
        color: const Color(0xFF9E9E9E),
        borderType: BorderType.RRect,
        radius: const Radius.circular(10.0),
        child: Center(
          child: Container(
            height: _uikSelectFilesProps.height,
            width: _uikSelectFilesProps.width,
            alignment: Alignment.center,
            padding: EdgeInsets.only(
              left: _uikSelectFilesProps.leftPadding,
              right: _uikSelectFilesProps.rightPadding,
              top: _uikSelectFilesProps.topPadding,
              bottom: _uikSelectFilesProps.bottomPadding,
            ),
            decoration: BoxDecoration(
              borderRadius: BorderRadius.circular(10.0),
            ),
            child: Center(
              child: RichText(
                textAlign: TextAlign.center,
                text: const TextSpan(
                  text: "Select the documents\nfrom ",
                  style: TextStyle(
                    color: Color(0xFF9E9E9E),
                  ),
                  children: [
                    TextSpan(
                      text: "files",
                      style: TextStyle(
                        color: Color(0xFF3F51B5),
                      ),
                    ),
                  ],
                ),
              ),
              /* Text(
                "Select the documents\nfrom files",
                textAlign: TextAlign.center,
                style: TextStyle(
                  color: Color(0xFF9E9E9E),
                ),
              ), */
            ),
          ),
        ),
      ),
    );
  }
}
