import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';

import '../props/UikSimpleColumnProps.dart';

class UikSimpleColumn extends UikWidget {
  WidgetType _widgetType;
  UikSimpleColumnProps _UikColumnProps;
  UikSimpleColumn(this._widgetType, this._UikColumnProps)
      : super(_widgetType, _UikColumnProps);
  @override
  _UikColumnState createState() => _UikColumnState(_UikColumnProps);
}

class _UikColumnState extends State<UikSimpleColumn> {
  UikSimpleColumnProps _uikColumnProps;
  _UikColumnState(this._uikColumnProps);

  @override
  Widget build(BuildContext context) {
    return Container(
      alignment: _uikColumnProps.alignment,
      padding: EdgeInsets.fromLTRB(
        _uikColumnProps.leftMargin,
        _uikColumnProps.topMargin,
        _uikColumnProps.rightMargin,
        _uikColumnProps.bottomMargin,
      ),
      child: Column(
        mainAxisAlignment: _uikColumnProps.mainAxisAlignment,
        crossAxisAlignment: _uikColumnProps.crossAxisAlignment,
        children: _uikColumnProps.widgets,
      ),
    );
  }
}
