import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import '../props/UikSimpleRowProps.dart';

class UikSimpleRow extends UikWidget {
  WidgetType _widgetType;
  UikSimpleRowProps _UikRowProps;
  UikSimpleRow(this._widgetType, this._UikRowProps)
      : super(_widgetType, _UikRowProps);
  @override
  _UikRowState createState() => _UikRowState(_UikRowProps);
}

class _UikRowState extends State<UikSimpleRow> {
  UikSimpleRowProps _uikColumnProps;
  _UikRowState(this._uikColumnProps);

  @override
  Widget build(BuildContext context) {
    return Container(
      alignment: _uikColumnProps.alignment,
      padding: EdgeInsets.fromLTRB(
        _uikColumnProps.leftMargin,
        _uikColumnProps.topMargin,
        _uikColumnProps.rightMargin,
        _uikColumnProps.bottomMargin,
      ),
      child: Row(
        mainAxisAlignment: _uikColumnProps.mainAxisAlignment,
        crossAxisAlignment: _uikColumnProps.crossAxisAlignment,
        children: _uikColumnProps.widgets,
      ),
    );
  }
}
