import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';

import '../props/UikStepperProps.dart';

class UikStepper extends UikWidget {
  WidgetType _widgetType;
  UikStepperProps _UikStepperProps;
  UikStepper(this._widgetType, this._UikStepperProps)
      : super(_widgetType, _UikStepperProps);

  @override
  _UikStepperState createState() => _UikStepperState(_UikStepperProps);
}

class _UikStepperState extends State<UikStepper> {
  UikStepperProps _UikStepperProps;
  _UikStepperState(this._UikStepperProps);

  int index = 0;

  @override
  Widget build(BuildContext context) {
    return Row(
      crossAxisAlignment: CrossAxisAlignment.center,
      mainAxisSize: MainAxisSize.min,
      children: [
        //..........................................Minus Image.......................................................//
        InkWell(
          onTap: () => {
            if (index > _UikStepperProps.lowerLimit) ...[
              setState(() {
                index--;
              }),
            ],
          },
          child: MouseRegion(
            cursor: SystemMouseCursors.click,
            child: Container(
              height: 36.0,
              width: 36.0,
              decoration: BoxDecoration(
                borderRadius: BorderRadius.circular(8),
                color: const Color(0xFFFEE440),
              ),
              child: _UikStepperProps.minusIcon,
            ),
          ),
        ),

        const SizedBox(width: 8.0),

        //..................................................TextNumber..........................................//
        SizedBox(
          width: 9,
          height: 21,
          // margin:
          //     const EdgeInsets.only(top: 8, bottom: 7, right: 19, left: 19),
          child: Text(
            "$index",
            textAlign: TextAlign.center,
          ),
        ),

        const SizedBox(width: 8.0),

        //...........................................Plus Image.................................................//

        InkWell(
          onTap: () => {
            if (index < _UikStepperProps.upperLimit) ...[
              setState(() {
                index++;
              }),
            ],
          },
          child: MouseRegion(
            cursor: SystemMouseCursors.click,
            child: Container(
              height: 36.0,
              width: 36.0,
              decoration: BoxDecoration(
                borderRadius: BorderRadius.circular(8),
                color: const Color(0xFFFEE440),
              ),
              child: _UikStepperProps.plusIcon,
            ),
          ),
        ),
      ],
    );
  }
}
