import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/models/Action.dart';
import 'package:ui_sdk/props/UikTextProps.dart';

class UikText extends UikWidget {
  WidgetType _widgetType;
  UikTextProps _uikTextProps;
  UikText(this._widgetType, this._uikTextProps)
      : super(_widgetType, _uikTextProps);

  @override
  _UikTextState createState() => _UikTextState(_uikTextProps);
}

class _UikTextState extends State<UikText> {
  final UikTextProps _uikTextProps;
  _UikTextState(this._uikTextProps);

  @override
  Widget build(BuildContext context) {
    return Container(
      margin: EdgeInsets.fromLTRB(
        _uikTextProps.leftMargin,
        _uikTextProps.topMargin,
        _uikTextProps.rightMargin,
        _uikTextProps.bottomMargin,
      ),
      child: Text(
        _uikTextProps.text,
        style: TextStyle(
          fontFamily: _uikTextProps.fontFamily,
          decoration: _uikTextProps.isStrike
              ? TextDecoration.lineThrough
              : TextDecoration.none,
          fontSize: _uikTextProps.size,
          fontWeight: _uikTextProps.fontWeight,
          color: _uikTextProps.color,
        ),
        textAlign: _uikTextProps.textAlign,
      ),
    );
  }
}
