import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikTextAreaProps.dart';

// ignore: must_be_immutable
class UikTextArea extends UikWidget {
  WidgetType _widgetType;
  UikTextAreaProps _uikTextAreaProps;
  UikTextArea(this._widgetType, this._uikTextAreaProps)
      : super(_widgetType, _uikTextAreaProps);

  @override
  _UikTextAreaState createState() => _UikTextAreaState(_uikTextAreaProps);
}

class _UikTextAreaState extends State<UikTextArea> {
  UikTextAreaProps _uikTextAreaProps;
  _UikTextAreaState(this._uikTextAreaProps);

  @override
  Widget build(BuildContext context) {
    return Container(
      child: Column(
        mainAxisAlignment: MainAxisAlignment.start,
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          // CONTAINER FOR LABEL
          if (_uikTextAreaProps.isLabel == true) ...[
            Text(
              _uikTextAreaProps.label,
              style: GoogleFonts.montserrat(
                  textStyle: Theme.of(context).textTheme.bodyMedium,
                  fontSize: 13,
                  fontWeight: FontWeight.w600,
                  color: Color(0xff212121)),
            ),
          ],

          //CONTAINER FOR TEXT AREA
          Container(
            margin: EdgeInsets.only(top: 5),
            height: _uikTextAreaProps.height,
            width: _uikTextAreaProps.width,
            child: TextField(
              expands: true,
              maxLines: null,
              textAlign: TextAlign.start,
              textAlignVertical: TextAlignVertical.top,
              decoration: InputDecoration(
                  hintMaxLines: 2,
                  contentPadding: EdgeInsets.fromLTRB(15, 10, 5, 15),
                  hintText: _uikTextAreaProps.text,
                  hintStyle: GoogleFonts.montserrat(
                      textStyle: Theme.of(context).textTheme.bodyMedium,
                      fontSize: 13,
                      fontWeight: FontWeight.w500,
                      color: const Color(0xff9e9e9e)),
                  enabledBorder: OutlineInputBorder(
                    borderRadius: (_uikTextAreaProps.corner == 'rounded')
                        ? (const BorderRadius.all(Radius.circular(15)))
                        : (const BorderRadius.all(Radius.circular(8))),
                    borderSide: (_uikTextAreaProps.isBorder == true)
                        ? (BorderSide(
                            color: _uikTextAreaProps.borderColor!, width: 1.0))
                        : (BorderSide.none),
                  ),
                  focusedBorder: OutlineInputBorder(
                    borderRadius: (_uikTextAreaProps.corner == 'rounded')
                        ? (const BorderRadius.all(Radius.circular(15)))
                        : (const BorderRadius.all(Radius.circular(8))),
                    borderSide: (_uikTextAreaProps.isBorder == true)
                        ? (BorderSide(
                            color: _uikTextAreaProps.borderColor!, width: 1.0))
                        : (BorderSide.none),
                  ),
                  filled:
                      (_uikTextAreaProps.transparency == true) ? false : true,
                  fillColor: _uikTextAreaProps.backgroundColor,
                  hoverColor: _uikTextAreaProps.backgroundColor),
            ),
          )
        ],
      ),
    );
  }
}
