// ignore_for_file: prefer_final_fields, no_logic_in_create_state

import "package:flutter/material.dart";
import 'package:google_fonts/google_fonts.dart';
import 'package:ui_sdk/components/WidgetType.dart';

import '../props/UikTextRadioButtonProps.dart';
import 'UikWidget.dart';

// ignore: must_be_immutable
class UikTextRadioButton extends UikWidget {
  // ignore: unused_field
  WidgetType _widgetType;
  UikTextRadioButtonProps _uikTextRadioButtonProps;
  UikTextRadioButton(this._widgetType, this._uikTextRadioButtonProps)
      : super(_widgetType, _uikTextRadioButtonProps);

  @override
  _UikTextRadioButtonState createState() =>
      _UikTextRadioButtonState(_uikTextRadioButtonProps);
}

class _UikTextRadioButtonState extends State<UikTextRadioButton> {
  final List<String> items = [
    "Furniture",
    "Lighting",
    "Rugs",
    "Mirrors",
    "Blankets",
    "Cushions",
    "Curtains",
    "Baskets",
    "Vases"
  ];
  UikTextRadioButtonProps _uikTextRadioButtonProps;
  _UikTextRadioButtonState(this._uikTextRadioButtonProps);

  @override
  Widget build(BuildContext context) {
    return Container(
      margin: EdgeInsets.only(
        top: _uikTextRadioButtonProps.marginTop,
        bottom: _uikTextRadioButtonProps.marginBottom,
        right: _uikTextRadioButtonProps.marginRight,
        left: _uikTextRadioButtonProps.marginLeft,
      ),
      child: SingleChildScrollView(
        child: Column(
          children: [
            for (int i = 0; i < items.length; i++) ...[
              Container(
                margin: const EdgeInsets.only(
                  left: 16.0,
                  right: 16.0,
                  bottom: 40.0,
                ),
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    Text(
                      items[i],
                      style: GoogleFonts.poppins(
                        textStyle: Theme.of(context).textTheme.bodyMedium,
                        fontSize: 16.0,
                        fontWeight: FontWeight.w400,
                      ),
                    ),
                    _uikTextRadioButtonProps.radiobutton!,
                  ],
                ),
              ),
            ]
          ],
        ),
      ),
    );
  }
}
