import "package:flutter/material.dart";
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:youtube_player_flutter/youtube_player_flutter.dart';

import '../props/UikVideoPlayerProps.dart';
import 'UikWidget.dart';

class UikVideoPlayer extends UikWidget {
  WidgetType _widgetType;
  UikVideoPlayerProps _uikVideoPlayerProps;
  UikVideoPlayer(this._widgetType, this._uikVideoPlayerProps)
      : super(_widgetType, _uikVideoPlayerProps);
  late String videoUrl;
  @override
  _UikVideoPlayerState createState() =>
      _UikVideoPlayerState(_uikVideoPlayerProps);
}

class _UikVideoPlayerState extends State<UikVideoPlayer> {
  UikVideoPlayerProps _uikVideoPlayerProps;
  late YoutubePlayerController _controller;
  late String videoUrl;
  _UikVideoPlayerState(this._uikVideoPlayerProps);
  void initState() {
    final String videoId = YoutubePlayer.convertUrlToId(videoUrl).toString();
    _controller = YoutubePlayerController(
        initialVideoId: videoId,
        flags: const YoutubePlayerFlags(
          autoPlay: true,
        ));
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      child: YoutubePlayer(
        controller: _controller,
        showVideoProgressIndicator:
            _uikVideoPlayerProps.showVideoProgressIndicator,
        aspectRatio: _uikVideoPlayerProps.aspectRatio,
      ),
    );
  }
}
