import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikButton.dart';
import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';

import '../props/UikmyAgentProps.dart';
import 'UikScrollProducts.dart';

class UikMyAgent extends UikWidget {
  WidgetType _widgetType;
  UikMyAgentProps _UikMyAgentProps;
  UikMyAgent(this._widgetType, this._UikMyAgentProps)
      : super(_widgetType, _UikMyAgentProps);

  @override
  _UikMyAgentState createState() => _UikMyAgentState(_UikMyAgentProps);
}

class _UikMyAgentState extends State<UikMyAgent> {
  UikMyAgentProps _UikMyAgentProps;
  _UikMyAgentState(this._UikMyAgentProps);
  final ScrollController controller = ScrollController();

  @override
  Widget build(BuildContext context) {
    return Container(
        width: _UikMyAgentProps.width,
        height: _UikMyAgentProps.height,
        child: ClipRRect(
          borderRadius: BorderRadius.circular(20.0),
          child: Card(
            child: Column(
              children: [
                Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    UikText(WidgetType.UikText, _UikMyAgentProps.containerText),
                    UikButton(
                        WidgetType.UikButton, _UikMyAgentProps.buttonText2)
                  ],
                ),
                UikScrollProducts(
                  WidgetType.UikScrollProducts,
                  _UikMyAgentProps.scrollProductsProps,
                ),
                Row(
                  mainAxisAlignment: MainAxisAlignment.center,
                  children: [
                    UikButton(
                      WidgetType.UikButton,
                      _UikMyAgentProps.buttonText,
                    )
                  ],
                )
              ],
            ),
          ),
        ));
  }
}
