import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikTextChipProps.dart';

class UikTextChip extends UikWidget {
  final WidgetType _widgetType;
  final UikTextChipProps _uikTextChipProps;
  UikTextChip(this._widgetType, this._uikTextChipProps)
      : super(_widgetType, _uikTextChipProps);

  @override
  _UikTextChipState createState() => _UikTextChipState(_uikTextChipProps);
}

class _UikTextChipState extends State<UikTextChip> {
  final UikTextChipProps _uikTextChipProps;
  _UikTextChipState(this._uikTextChipProps);

  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: EdgeInsets.only(
        left: _uikTextChipProps.leftMargin,
        right: _uikTextChipProps.rightMargin,
        top: _uikTextChipProps.topMargin,
        bottom: _uikTextChipProps.bottomMargin,
      ),
      child: Chip(
        label: _uikTextChipProps.text,
        backgroundColor: _uikTextChipProps.bgColor,
        shape: RoundedRectangleBorder(
          borderRadius: BorderRadius.circular(_uikTextChipProps.borderRadius),
        ),
      ),
    );
    /* return Container(
      padding: const EdgeInsets.all(8.0),
      decoration: BoxDecoration(
        color: _uikTextChipProps.bgColor,
        borderRadius: BorderRadius.circular(_uikTextChipProps.borderRadius),
      ),
      child: _uikTextChipProps.text,
    ); */
  }
}
