import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikIconProps.dart';

import '../../components/UikIcon.dart';
import '../../props/UikCenterRowProps.dart';
import '../../props/UikTextProps.dart';

UikCenterRowProps $UikCenterRowPropsFromJson(Map<String, dynamic> json) {
  final UikCenterRowProps uikCenterRowProps = UikCenterRowProps();

  final String? id = jsonConvert.convert<String>(json['id']);

  final double? leftMargin = jsonConvert.convert<double>(json["leftMargin"]);
  final double? rightMargin = jsonConvert.convert<double>(json["rightMargin"]);
  final double? topMargin = jsonConvert.convert<double>(json["topMargin"]);
  final double? bottomMargin =
      jsonConvert.convert<double>(json["bottomMargin"]);

  final String? icon = jsonConvert.convert<String>(json["icon"]);

  final String? text = jsonConvert.convert<String>(json["text"]);

  if (id != null) {
    uikCenterRowProps.id = id;
  }

  if (leftMargin != null) {
    uikCenterRowProps.leftMargin = leftMargin;
  }

  if (rightMargin != null) {
    uikCenterRowProps.rightMargin = rightMargin;
  }

  if (topMargin != null) {
    uikCenterRowProps.topMargin = topMargin;
  }

  if (bottomMargin != null) {
    uikCenterRowProps.bottomMargin = bottomMargin;
  }

  if (icon != null) {
    uikCenterRowProps.icon =
        UikIcon(WidgetType.UikText, UikIconProps.fromJson(json["icon"]));
  }

  if (text != null) {
    uikCenterRowProps.text =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json["text"]));
  }

  return uikCenterRowProps;
}

Map<String, dynamic> $UikCenterRowPropsToJson(UikCenterRowProps entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['id'] = entity.id;
  // data['src'] = entity.src;
  // data['action'] = entity.action.toJson();
  return data;
}
