import 'package:ui_sdk/components/UikColumn.dart';
import 'package:ui_sdk/components/UikContainerText.dart';
import 'package:ui_sdk/components/UikImage.dart';
import 'package:ui_sdk/components/UikListTile.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikColumnProps.dart';
import 'package:ui_sdk/props/UikContainerTextProps.dart';
import 'package:ui_sdk/props/UikImageProps.dart';

import '../../components/UikAvatar.dart';
import '../../components/UikButton.dart';
import '../../components/UikSimpleColumn.dart';
import '../../components/UikText.dart';
import '../../props/UikAvatarProps.dart';
import '../../props/UikButtonProps.dart';
import '../../props/UikListTileProps.dart';
import '../../props/UikRowProps.dart';
import '../../props/UikSimpleColumnProps.dart';
import '../../props/UikTextProps.dart';

UikRowProps $UikRowPropsFromJson(Map<String, dynamic> json) {
  final UikRowProps uikRowProps = UikRowProps();

  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikRowProps.id = id;
  }

  final List<dynamic>? widgets =
      jsonConvert.convert<List<dynamic>>(json["widgets"]);
  if (widgets != null) {
    for (int i = 0; i < widgets.length; i++) {
      if (widgets[i]["id"] == "image") {
        uikRowProps.widgets.add(UikImage(
            WidgetType.UikImage, UikImageProps.fromJson(json["widgets"][i])));
      }

      if (widgets[i]["id"] == "text") {
        uikRowProps.widgets.add(UikContainerText(WidgetType.UikText,
            UikContainerTextProps.fromJson(json["widgets"][i])));
      }

      if (widgets[i]["id"] == "UikListTile") {
        uikRowProps.widgets.add(UikListTile(WidgetType.UikListTile,
            UikListTileProps.fromJson(json["widgets"][i])));
      }

      if (widgets[i]["id"] == "button") {
        uikRowProps.widgets.add(UikButton(
            WidgetType.UikButton, UikButtonProps.fromJson(json["widgets"][i])));
      }
      if (widgets[i]["id"] == "UikColumn") {
        uikRowProps.widgets.add(UikColumn(
            WidgetType.UikButton, UikColumnProps.fromJson(json["widgets"][i])));
      }
      if (widgets[i]["id"] == "UikSimpleColumn") {
        uikRowProps.widgets.add(UikSimpleColumn(WidgetType.UikSimpleColumn,
            UikSimpleColumnProps.fromJson(json["widgets"][i])));
      }
      if (widgets[i]["id"] == "avatar") {
        uikRowProps.widgets.add(UikAvatar(
            WidgetType.UikAvatar, UikAvatarProps.fromJson(json["widgets"][i])));
      }
      if (widgets[i]["id"] == "txt") {
        uikRowProps.widgets.add(UikText(
            WidgetType.UikText, UikTextProps.fromJson(json["widgets"])));
      }
    }
  }

  final double? leftMargin = jsonConvert.convert<double>(json["leftMargin"]);
  if (leftMargin != null) {
    uikRowProps.leftMargin = leftMargin;
  }

  final double? rightMargin = jsonConvert.convert<double>(json["rightMargin"]);
  if (rightMargin != null) {
    uikRowProps.rightMargin = rightMargin;
  }

  final double? topMargin = jsonConvert.convert<double>(json["topMargin"]);
  if (topMargin != null) {
    uikRowProps.topMargin = topMargin;
  }

  final double? bottomMargin =
      jsonConvert.convert<double>(json["bottomMargin"]);
  if (bottomMargin != null) {
    uikRowProps.bottomMargin = bottomMargin;
  }

  return uikRowProps;
}

Map<String, dynamic> $UikRowPropsToJson(UikRowProps entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['id'] = entity.id;
  // data['src'] = entity.src;
  // data['action'] = entity.action.toJson();
  return data;
}
