import 'package:ui_sdk/components/UikButton.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';

import '../../components/WidgetType.dart';
import '../../props/UikSortFilterProps.dart';

UikSortFilterProps $UikSortFilterPropsFromJson(Map<String, dynamic> json) {
  final UikSortFilterProps uikSortFilterProps = UikSortFilterProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikSortFilterProps.id = id;
  }

  final String? sortButton = jsonConvert.convert<String>(json['sortButton']);
  if (sortButton != null) {
    uikSortFilterProps.sortButton = UikButton(
        WidgetType.UikText, UikButtonProps.fromJson(json['sortButton']));
  }

  final String? filterButton =
      jsonConvert.convert<String>(json['filterButton']);
  if (filterButton != null) {
    uikSortFilterProps.filterButton = UikButton(
        WidgetType.UikText, UikButtonProps.fromJson(json['filterButton']));
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikSortFilterProps.action = action;
  }
  return uikSortFilterProps;
}
