import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';

import '../../components/UikThreeColumnTile.dart';
import '../../props/UikThreeColumnTileListProps.dart';
import '../../props/UikThreeColumnTileProps.dart';

UikThreeColumnTileListProps $UikThreeColumnTileListPropsFromJson(
    Map<String, dynamic> json) {
  final UikThreeColumnTileListProps uikThreeColumnTileListProps =
      UikThreeColumnTileListProps();

  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikThreeColumnTileListProps.id = id;
  }

  final double? height = jsonConvert.convert<double>(json["height"]);
  if (height != null) {
    uikThreeColumnTileListProps.height = height;
  }

  final double? leftMargin = jsonConvert.convert<double>(json["leftMargin"]);
  if (leftMargin != null) {
    uikThreeColumnTileListProps.leftMargin = leftMargin;
  }

  final double? rightMargin = jsonConvert.convert<double>(json["rightMargin"]);
  if (rightMargin != null) {
    uikThreeColumnTileListProps.rightMargin = rightMargin;
  }

  final double? topMargin = jsonConvert.convert<double>(json["topMargin"]);
  if (topMargin != null) {
    uikThreeColumnTileListProps.topMargin = topMargin;
  }

  final double? bottomMargin =
      jsonConvert.convert<double>(json["bottomMargin"]);
  if (bottomMargin != null) {
    uikThreeColumnTileListProps.bottomMargin = bottomMargin;
  }

  final List<dynamic>? tiles =
      jsonConvert.convert<List<dynamic>>(json['tiles']);
  if (tiles != null) {
    for (int i = 0; i < tiles.length; i++) {
      uikThreeColumnTileListProps.tiles.add(
        UikThreeColumnTile(
          WidgetType.UikListTile,
          UikThreeColumnTileProps.fromJson(tiles[i]),
        ),
      );
    }
  }

  final List<UikAction>? actionList =
      jsonConvert.convert<List<UikAction>>(json["actionList"]);
  if (actionList != null) {
    for (int i = 0; i < actionList.length; i++) {
      uikThreeColumnTileListProps.actionList.add(actionList[i]);
    }
  }

  return uikThreeColumnTileListProps;
}
