import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikIconProps.dart';

import '../../components/UikIcon.dart';
import '../../props/UikTextProps.dart';
import '../../props/UikTopBarProps.dart';

UikTopBarProps $UikTopBarPropsFromJson(Map<String, dynamic> json) {
  final UikTopBarProps uikTopBarProps = UikTopBarProps();

  final String? id = jsonConvert.convert<String>(json['id']);

  final double? leftPadding = jsonConvert.convert<double>(json["leftPadding"]);
  final double? rightPadding =
      jsonConvert.convert<double>(json["rightPadding"]);
  final double? topPadding = jsonConvert.convert<double>(json["topPadding"]);
  final double? bottomPadding =
      jsonConvert.convert<double>(json["bottomPadding"]);

  final String? icon = jsonConvert.convert<String>(json["icon"]);

  final String? text = jsonConvert.convert<String>(json["text"]);

  if (id != null) {
    uikTopBarProps.id = id;
  }

  if (leftPadding != null) {
    uikTopBarProps.leftPadding = leftPadding;
  }

  if (rightPadding != null) {
    uikTopBarProps.rightPadding = rightPadding;
  }

  if (topPadding != null) {
    uikTopBarProps.topPadding = topPadding;
  }

  if (bottomPadding != null) {
    uikTopBarProps.bottomPadding = bottomPadding;
  }

  if (icon != null) {
    uikTopBarProps.icon =
        UikIcon(WidgetType.UikText, UikIconProps.fromJson(json["icon"]));
  }

  if (text != null) {
    uikTopBarProps.text =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['text']));
  }

  return uikTopBarProps;
}

Map<String, dynamic> $UikTopBarPropsToJson(UikTopBarProps entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['id'] = entity.id;
  // data['src'] = entity.src;
  // data['action'] = entity.action.toJson();
  return data;
}
