import 'package:ui_sdk/components/UikAvatar.dart';
import 'package:ui_sdk/components/UikButton.dart';
import 'package:ui_sdk/components/UikCell.dart';
import 'package:ui_sdk/components/UikContainerText.dart';
import 'package:ui_sdk/components/UikIconText.dart';
import 'package:ui_sdk/components/UikImage.dart';
import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/components/UikTwoComponentRow.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAvatarProps.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/props/UikCellProps.dart';
import 'package:ui_sdk/props/UikContainerTextProps.dart';
import 'package:ui_sdk/props/UikIconProps.dart';
import 'package:ui_sdk/props/UikIconTextProps.dart';
import 'package:ui_sdk/props/UikImageProps.dart';
import 'package:ui_sdk/props/UikTwoComponentRowProps.dart';
import 'package:ui_sdk/utils/UiSdkUtils.dart';

import '../../components/UikIcon.dart';
import '../../props/UikColumnProps.dart';
import '../../props/UikTextProps.dart';

UikColumnProps $UikColumnPropsFromJson(Map<String, dynamic> json) {
  final UikColumnProps uikColumnProps = UikColumnProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikColumnProps.id = id;
  }

  final List<dynamic>? widgets =
      jsonConvert.convert<List<dynamic>>(json["widgets"]);
  if (widgets != null) {
    for (int i = 0; i < widgets.length; i++) {
      if (widgets[i]["id"] == "image") {
        uikColumnProps.widgets.add(UikImage(
            WidgetType.UikImage, UikImageProps.fromJson(json["widgets"][i])));
      }

      if (widgets[i]["id"] == "text") {
        uikColumnProps.widgets.add(UikContainerText(WidgetType.UikText,
            UikContainerTextProps.fromJson(json["widgets"][i])));
      }

      if (widgets[i]["id"] == "avatar") {
        UiSdkUtils.prettyPrintJson(widgets[i]);

        uikColumnProps.widgets.add(UikAvatar(
            WidgetType.UikAvatar, UikAvatarProps.fromJson(json["widgets"][i])));
      }
      if (widgets[i]["id"] == "icon") {
        uikColumnProps.widgets.add(UikIcon(
            WidgetType.UikText, UikIconProps.fromJson(json["widgets"][i])));
      }

      if (widgets[i]["id"] == "text1") {
        // UiSdkUtils.prettyPrintJson(widgets[i]);

        uikColumnProps.widgets.add(UikText(
            WidgetType.UikText, UikTextProps.fromJson(json["widgets"][i])));
      }

      if (widgets[i]["id"] == "cell") {
        uikColumnProps.widgets.add(UikCell(
            WidgetType.UikText, UikCellProps.fromJson(json["widgets"][i])));
      }

      if (widgets[i]["id"] == "itext") {
        uikColumnProps.widgets.add(UikIconText(
            WidgetType.UikText, UikIconTextProps.fromJson(json["widgets"][i])));
      }

      if (widgets[i]["id"] == "button") {
        uikColumnProps.widgets.add(UikButton(
            WidgetType.UikText, UikButtonProps.fromJson(json["widgets"][i])));
      }

      if (widgets[i]["id"] == "twoRow") {
        uikColumnProps.widgets.add(UikTwoComponentRow(WidgetType.UikText,
            UikTwoComponentRowProps.fromJson(json["widgets"][i])));
      }
    }
  }

  final double? leftMargin = jsonConvert.convert<double>(json["leftMargin"]);
  if (leftMargin != null) {
    uikColumnProps.leftMargin = leftMargin;
  }

  final double? height = jsonConvert.convert<double>(json["height"]);
  if (height != null) {
    uikColumnProps.height = height;
  }

  final double? rightMargin = jsonConvert.convert<double>(json["rightMargin"]);
  if (rightMargin != null) {
    uikColumnProps.rightMargin = rightMargin;
  }

  final double? topMargin = jsonConvert.convert<double>(json["topMargin"]);
  if (topMargin != null) {
    uikColumnProps.topMargin = topMargin;
  }

  final double? bottomMargin =
      jsonConvert.convert<double>(json["bottomMargin"]);
  if (bottomMargin != null) {
    uikColumnProps.bottomMargin = bottomMargin;
  }

  return uikColumnProps;
}

Map<String, dynamic> $UikColumnPropsToJson(UikColumnProps entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['id'] = entity.id;
  // data['src'] = entity.src;
  // data['action'] = entity.action.toJson();
  return data;
}
