import 'package:ui_sdk/components/UikIcon.dart';
import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikTextProps.dart';

import '../../components/UikImage.dart';
import '../../props/UikEarningCardProps.dart';
import '../../props/UikIconProps.dart';
import '../../props/UikImageProps.dart';

UikEarningCardProps $UikEarningCardPropsFromJson(Map<String, dynamic> json) {
  final UikEarningCardProps uikEarningCardProps = UikEarningCardProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikEarningCardProps.id = id;
  }
  final Map<String, dynamic>? leading =
      jsonConvert.convert<dynamic>(json['leading']);
  if (leading != null && leading['id'] == 'coinImage') {
    uikEarningCardProps.leading = UikImage(
      WidgetType.UikImage,
      UikImageProps.fromJson(
        json['leading'],
      ),
    );
  }

  final Map<String, dynamic>? trailing =
      jsonConvert.convert<dynamic>(json['trailing']);
  if (trailing != null && trailing['id'] == 'rightIcon') {
    uikEarningCardProps.trailing = UikIcon(
      WidgetType.UikImage,
      UikIconProps.fromJson(
        json['trailing'],
      ),
    );
  }

  final Map<String, dynamic>? title =
      jsonConvert.convert<dynamic>(json['title']);
  if (title != null && title['id'] == 'listTileTitle') {
    uikEarningCardProps.title = UikText(
      WidgetType.UikText,
      UikTextProps.fromJson(
        json['title'],
      ),
    );
  }

  final Map<String, dynamic>? subTitle =
      jsonConvert.convert<dynamic>(json['subTitle']);

  if (subTitle != null && subTitle['id'] == 'listTileSubTitle') {
    uikEarningCardProps.subTitle = UikText(
      WidgetType.UikText,
      UikTextProps.fromJson(
        json['subTitle'],
      ),
    );
  }

  final Map<String, dynamic>? bottomLeftTitle =
      jsonConvert.convert<dynamic>(json['bottomLeftTitle']);
  if (bottomLeftTitle != null && bottomLeftTitle['id'] == 'bottomLeftTitle') {
    uikEarningCardProps.bottomLeftTitle = UikText(
      WidgetType.UikText,
      UikTextProps.fromJson(
        json['bottomLeftTitle'],
      ),
    );
  }

  final Map<String, dynamic>? bottomLeftSubTitle =
      jsonConvert.convert<dynamic>(json['bottomLeftSubTitle']);

  if (bottomLeftSubTitle != null &&
      bottomLeftSubTitle['id'] == 'bottomLeftSubTitle') {
    uikEarningCardProps.bottomLeftSubTitle = UikText(
      WidgetType.UikText,
      UikTextProps.fromJson(
        json['bottomLeftSubTitle'],
      ),
    );
  }

  final Map<String, dynamic>? bottomRightTitle =
      jsonConvert.convert<dynamic>(json['bottomRightTitle']);

  if (bottomRightTitle != null &&
      bottomRightTitle['id'] == 'bottomRightTitle') {
    uikEarningCardProps.bottomRightTitle = UikText(
      WidgetType.UikText,
      UikTextProps.fromJson(
        json['bottomRightTitle'],
      ),
    );
  }

  final Map<String, dynamic>? bottomRightSubTitle =
      jsonConvert.convert<dynamic>(json['bottomRightSubTitle']);
  if (bottomRightSubTitle != null &&
      bottomRightSubTitle['id'] == 'bottomRightSubTitle') {
    uikEarningCardProps.bottomRightSubTitle = UikText(
      WidgetType.UikText,
      UikTextProps.fromJson(
        json['bottomRightSubTitle'],
      ),
    );
  }

  if (json['paddingBottom'] != null) {
    uikEarningCardProps.paddingBottom =
        jsonConvert.convert<double>(json['paddingBottom'])!;
  }
  if (json['paddingTop'] != null) {
    uikEarningCardProps.paddingTop =
        jsonConvert.convert<double>(json['paddingTop'])!;
  }

  if (json['paddingLeft'] != null) {
    uikEarningCardProps.paddingLeft =
        jsonConvert.convert<double>(json['paddingLeft'])!;
  }

  if (json['paddingRight'] != null) {
    uikEarningCardProps.paddingRight =
        jsonConvert.convert<double>(json['paddingRight'])!;
  }

  if (json['marginBottom'] != null) {
    uikEarningCardProps.marginBottom =
        jsonConvert.convert<double>(json['marginBottom'])!;
  }

  if (json['marginTop'] != null) {
    uikEarningCardProps.marginTop =
        jsonConvert.convert<double>(json['marginTop'])!;
  }

  if (json['marginLeft'] != null) {
    uikEarningCardProps.marginLeft =
        jsonConvert.convert<double>(json['marginLeft'])!;
  }

  if (json['marginRight'] != null) {
    uikEarningCardProps.marginRight =
        jsonConvert.convert<double>(json['marginRight'])!;
  }

  return uikEarningCardProps;
}
