import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikTextProps.dart';

import '../../components/WidgetType.dart';
import '../../props/UikListTilesProps.dart';

UikListTilesProps $UikListTilesPropsFromJson(Map<String, dynamic> json) {
  final UikListTilesProps uikListTilesProps = UikListTilesProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikListTilesProps.id = id;
  }
  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikListTilesProps.action = action;
  }
  final String? leadText = jsonConvert.convert<String>(json['leadText']);
  if (leadText != null) {
    uikListTilesProps.leadingText =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['leadText']));
  }
  final String? trailText = jsonConvert.convert<String>(json['trailText']);
  if (trailText != null) {
    uikListTilesProps.trailingText =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['trailText']));
  }
  final double? topMargin = jsonConvert.convert<double>(json['topMargin']);
  if (topMargin != null) {
    uikListTilesProps.topMargin = topMargin;
  }
  final double? bottomMargin =
      jsonConvert.convert<double>(json['bottomMargin']);
  if (bottomMargin != null) {
    uikListTilesProps.bottomMargin = bottomMargin;
  }
  final double? sideMargin = jsonConvert.convert<double>(json['sideMargin']);
  if (sideMargin != null) {
    uikListTilesProps.sideMargin = sideMargin;
  }
  return uikListTilesProps;
}
