import 'package:ui_sdk/components/UikButton.dart';
import 'package:ui_sdk/components/UikContainerText.dart';
import 'package:ui_sdk/components/UikTwoComponentRow.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/props/UikContainerTextProps.dart';
import 'package:ui_sdk/props/UikProductCardProps.dart';

import '../../components/UikStepper.dart';
import '../../components/WidgetType.dart';
import '../../props/UikStepperProps.dart';
import '../../props/UikTwoComponentRowProps.dart';

UikProductCardProps $UikProductCardPropsFromJson(Map<String, dynamic> json) {
  final UikProductCardProps uikProductCardProps = UikProductCardProps();

  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikProductCardProps.id = id;
  }
  final String? productPrice =
      jsonConvert.convert<String>(json['productPrice']);
  if (productPrice != null) {
    uikProductCardProps.productPrice = productPrice;
  }

  final String? productDescription =
      jsonConvert.convert<String>(json['productDescription']);
  if (productDescription != null) {
    uikProductCardProps.productDescription = productDescription;
  }

  final String? imageUrl = jsonConvert.convert<String>(json['imageUrl']);
  if (imageUrl != null) {
    uikProductCardProps.imageUrl = imageUrl;
  }

  final String? trailing = jsonConvert.convert<String>(json['trailing']);
  if (trailing != null) {
    if (json["trailing"]["id"] == "button") {
      uikProductCardProps.trailing = UikButton(
          WidgetType.UikText, UikButtonProps.fromJson(json['trailing']));
    }

    if (json["trailing"]["id"] == "stepper") {
      uikProductCardProps.trailing = UikStepper(
          WidgetType.UikText, UikStepperProps.fromJson(json["trailing"]));
    }

    if (json["trailing"]["id"] == "text") {
      uikProductCardProps.trailing = UikContainerText(
          WidgetType.UikText, UikContainerTextProps.fromJson(json["trailing"]));
    }

    if (json["trailing"]["id"] == "twoComponentRow") {
      uikProductCardProps.trailing = UikTwoComponentRow(WidgetType.UikText,
          UikTwoComponentRowProps.fromJson(json["trailing"]));
    }
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikProductCardProps.action = action;
  }
  return uikProductCardProps;
}
