import 'package:ui_sdk/components/UikAvatar.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';

import '../../components/UikIcon.dart';
import '../../components/WidgetType.dart';
import '../../props/UikAvatarProps.dart';
import '../../props/UikIconProps.dart';
import '../../props/UikSelectProps.dart';

UikSelectProps $UikSelectPropsFromJson(Map<String, dynamic> json) {
  final UikSelectProps uikSelectProps = UikSelectProps();

  final String? avatar = jsonConvert.convert<String>(json['avatar']);
  if (avatar != null) {
    uikSelectProps.avatar =
        UikAvatar(WidgetType.UikText, UikAvatarProps.fromJson(json['avatar']));
  }

  final String? rightIcon = jsonConvert.convert<String>(json['rightIcon']);
  if (rightIcon != null) {
    uikSelectProps.rightIcon =
        UikIcon(WidgetType.UikText, UikIconProps.fromJson(json['rightIcon']));
  }

  final String? Corner = jsonConvert.convert<String>(json['Corner']);
  if (Corner != null) {
    uikSelectProps.Corner = Corner;
  }

  final bool? Border = jsonConvert.convert<bool>(json['Border']);
  if (Border != null) {
    uikSelectProps.Border = Border;
  }

  final bool? Disable = jsonConvert.convert<bool>(json['Disable']);
  if (Disable != null) {
    uikSelectProps.Disable = Disable;
  }

  final bool? Heading = jsonConvert.convert<bool>(json['Heading']);
  if (Heading != null) {
    uikSelectProps.Heading = Heading;
  }

  final bool? noIcon = jsonConvert.convert<bool>(json['noIcon']);
  if (noIcon != null) {
    uikSelectProps.noIcon = noIcon;
  }

  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikSelectProps.id = id;
  }
  final String? text = jsonConvert.convert<String>(json['text']);
  if (text != null) {
    uikSelectProps.text = text;
  }
  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikSelectProps.action = action;
  }
  return uikSelectProps;
}
