import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/getWidgets/uikButtonBar/UikButtonBarProps.dart';

class UikButtonBar extends UikWidget {
  WidgetType _widgetType;
  UikButtonBarProps _uikButtonBarProps;

  UikButtonBar(this._widgetType, this._uikButtonBarProps)
      : super(_widgetType, _uikButtonBarProps);

  @override
  _uikButtonBarState createState() => _uikButtonBarState(_uikButtonBarProps);
}

class _uikButtonBarState extends State<UikButtonBar> {
  UikButtonBarProps _uikButtonBarProps;

  _uikButtonBarState(this._uikButtonBarProps);

  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: _uikButtonBarProps.padding,
      child: Wrap(
        direction: _uikButtonBarProps.direction,
        alignment: _uikButtonBarProps.alignment,
        spacing: _uikButtonBarProps.spacing,
        runAlignment: _uikButtonBarProps.runAlignment,
        runSpacing: _uikButtonBarProps.runSpacing,
        crossAxisAlignment: _uikButtonBarProps.crossAxisAlignment,
        textDirection: _uikButtonBarProps.textDirection,
        verticalDirection: _uikButtonBarProps.verticalDirection,
        children: _uikButtonBarProps.children??[]
      ),
    );
  }
}
