import 'package:flutter/widgets.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/getWidgets/uikButtonBar/UikButtonBarProps.dart';

UikButtonBarProps $UikButtonBarPropsFromJson(Map<String, dynamic> json) {
  UikButtonBarProps uikButtonBarProps = UikButtonBarProps();
  final String? id = jsonConvert.convert(json['id']);
  if (id != null) {
    uikButtonBarProps.id = id;
  }
  final double? spacing = jsonConvert.convert(json['spacing']);
  if (spacing != null) {
    uikButtonBarProps.spacing = spacing;
  }
  final double? padding = jsonConvert.convert(json["padding"]);
  if (padding != null) {
    uikButtonBarProps.padding = EdgeInsets.all(padding);
  }
  final String? direction = jsonConvert.convert<String>(json['direction']);
  if (direction != null) {
    if (direction == 'horizontal') {
      uikButtonBarProps.direction = Axis.horizontal;
    } else {
      uikButtonBarProps.direction = Axis.vertical;
    }
  }
  final String? alignment = jsonConvert.convert<String>(json['alignment']);
  if (alignment != null) {
    if(alignment == 'start'){
      uikButtonBarProps.alignment = WrapAlignment.start;
    }else if(alignment == 'center'){
      uikButtonBarProps.alignment = WrapAlignment.center;
    }else if(alignment == 'end'){
      uikButtonBarProps.alignment = WrapAlignment.end;
    }else if(alignment == 'spaceAround'){
      uikButtonBarProps.alignment = WrapAlignment.spaceAround;
    }else if(alignment == 'spaceBetween'){
      uikButtonBarProps.alignment = WrapAlignment.spaceBetween;
    }else if(alignment == 'spaceEvenly'){
      uikButtonBarProps.alignment = WrapAlignment.spaceEvenly;
    }
  }
  final String? runAlignment =
      jsonConvert.convert<String>(json['runAlignment']);
  if (runAlignment != null) {
    if(runAlignment == 'start'){
      uikButtonBarProps.runAlignment = WrapAlignment.start;
    }else if(runAlignment == 'center'){
      uikButtonBarProps.runAlignment = WrapAlignment.center;
    }else if(runAlignment == 'end'){
      uikButtonBarProps.runAlignment = WrapAlignment.end;
    }else if(runAlignment == 'spaceAround'){
      uikButtonBarProps.runAlignment = WrapAlignment.spaceAround;
    }else if(runAlignment == 'spaceBetween'){
      uikButtonBarProps.runAlignment = WrapAlignment.spaceBetween;
    }else if(runAlignment == 'spaceEvenly'){
      uikButtonBarProps.runAlignment = WrapAlignment.spaceEvenly;
    }
  }
  final String? crossAxisAlignment =
      jsonConvert.convert<String>(json['crossAxisAlignment']);
  if (crossAxisAlignment != null) {
    if(crossAxisAlignment == 'start'){
      uikButtonBarProps.crossAxisAlignment = WrapCrossAlignment.start;
    }else if(crossAxisAlignment == 'center'){
      uikButtonBarProps.crossAxisAlignment = WrapCrossAlignment.center;
    }else if(crossAxisAlignment == 'end'){
      uikButtonBarProps.crossAxisAlignment = WrapCrossAlignment.end;
    }
  }
  final String? verticalDirection =
      jsonConvert.convert<String>(json['verticalDirection']);
  if (verticalDirection != null) {
    if(verticalDirection == 'down'){
      uikButtonBarProps.verticalDirection = VerticalDirection.down;
    }else if(verticalDirection == 'up'){
      uikButtonBarProps.verticalDirection = VerticalDirection.up;
    }
  }
  final double? runSpacing = jsonConvert.convert(json['runSpacing']);
  if (runSpacing != null) {
    uikButtonBarProps.runSpacing = runSpacing;
  }
  final String? children = jsonConvert.convert<String>(json['children']);
  if (children != null) {
    uikButtonBarProps.children = <Widget>[];
  }
  final String? textDirection =
      jsonConvert.convert<String>(json['textDirection']);
  if (textDirection != null) {
    if (textDirection == 'ltr') {
      uikButtonBarProps.textDirection = TextDirection.ltr;
    } else {
      TextDirection.rtl;
    }
  }

  return uikButtonBarProps;
}
