import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/getWidgets/uikImageOverlay/UikImageOverlayProps.dart';

class UikImageOverlay extends UikWidget {
  WidgetType _widgetType;
  UikImageOverlayProps _uikImageOverlayProps;

  UikImageOverlay(this._widgetType, this._uikImageOverlayProps)
      : super(_widgetType, _uikImageOverlayProps);

  @override
  _uikImageOverlayState createState() =>
      _uikImageOverlayState(_uikImageOverlayProps);
}

class _uikImageOverlayState extends State<UikImageOverlay> {
  UikImageOverlayProps _uikImageOverlayProps;

  _uikImageOverlayState(this._uikImageOverlayProps);

  @override
  Widget build(BuildContext context) {
    return Container(
      alignment: _uikImageOverlayProps.alignment,
      height: _uikImageOverlayProps.height,
      width: _uikImageOverlayProps.width ?? MediaQuery.of(context).size.width,
      margin: _uikImageOverlayProps.margin,
      padding: _uikImageOverlayProps.padding,
      decoration: BoxDecoration(
        shape: _uikImageOverlayProps.shape,
        borderRadius: _uikImageOverlayProps.borderRadius,
        border: _uikImageOverlayProps.border,
        color: _uikImageOverlayProps.color,
        image: DecorationImage(
          fit: _uikImageOverlayProps.boxFit,
          colorFilter: _uikImageOverlayProps.colorFilter,
          image: _uikImageOverlayProps.image!,
        ),
      ),
      child: _uikImageOverlayProps.child,
    );
  }
}
