import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/getWidgets/uikImageOverlay/uik_image_overlay_props.g.dart';
import 'package:ui_sdk/props/WidgetProps.dart';

@JsonSerializable()
class UikImageOverlayProps extends WidgetProps {
  String? id;
  double? height;
  double? width;
  Color? color;
  EdgeInsetsGeometry? margin;
  EdgeInsetsGeometry? padding;
  ImageProvider? image;
  Widget child = const Text('');
  AlignmentGeometry? alignment;
  BoxFit? boxFit;
  ColorFilter? colorFilter;
  BorderRadiusGeometry? borderRadius;
  Border? border;
  BoxShape shape = BoxShape.rectangle;

  UikImageOverlayProps();

  factory UikImageOverlayProps.fromJson(Map<String, dynamic> json) =>
      $UikImageOverlayPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }

  UikImageOverlayProps mockWidget() {
    return UikImageOverlayProps.fromJson(
      {
        'id': 'uikImageOverlay',
        'boxFit':'cover',
        'image':
            'https://media.istockphoto.com/id/149360161/photo/manicured-house-and-garden.jpg?s=1024x1024&w=is&k=20&c=G8tOU3hhMwgIrDorByYbBDBFFiqIcNaqdX7sXuywogc=',
        'child': {
          "id": "text",
          "text": "Hello this is overLayContent",
          "size": "24.0",
          "action": {
            "tap": {
              "type": "UIK_OPEN_WEB",
              "data": {
                "url":
                    "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
              }
            }
          }
        },
      },
    );
  }
}
