import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/getWidgets/uikListTile/UikGWListTileProps.dart';

class UikGWListTile extends UikWidget {
  WidgetType _widgetType;
  UikGWListTileProps _uikGWListTileProps;

  UikGWListTile(this._widgetType, this._uikGWListTileProps)
      : super(_widgetType, _uikGWListTileProps);

  @override
  _uikGWListTileState createState() => _uikGWListTileState(_uikGWListTileProps);
}

class _uikGWListTileState extends State<UikGWListTile> {
  UikGWListTileProps _uikGWListTileProps;

  _uikGWListTileState(this._uikGWListTileProps);

  @override
  Widget build(BuildContext context) {
    return InkWell(
      onTap: _uikGWListTileProps.enabled ? _uikGWListTileProps.onTap : null,
      onLongPress:
          _uikGWListTileProps.enabled ? _uikGWListTileProps.onLongPress : null,
      canRequestFocus: _uikGWListTileProps.enabled,
      focusNode: _uikGWListTileProps.focusNode,
      focusColor: _uikGWListTileProps.focusColor,
      hoverColor: _uikGWListTileProps.hoverColor,
      autofocus: _uikGWListTileProps.autofocus,
      child: Semantics(
        selected: _uikGWListTileProps.selected,
        enabled: _uikGWListTileProps.enabled,
        child: Container(
          // constraints: const BoxConstraints(minHeight: 50),
          padding: _uikGWListTileProps.padding,
          margin: _uikGWListTileProps.margin,
          decoration: BoxDecoration(
            color: _uikGWListTileProps.color,
            borderRadius: const BorderRadius.all(Radius.circular(5)),
          ),
          child: Row(
            mainAxisAlignment: MainAxisAlignment.spaceBetween,
            children: <Widget>[
              _uikGWListTileProps.avatar ?? Container(),
              Expanded(
                child: Padding(
                  padding: const EdgeInsets.symmetric(horizontal: 10),
                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: <Widget>[
                      // _uikGWListTileProps.titleText != null
                      //     ? Text(
                      //         _uikGWListTileProps.titleText!,
                      //         style: TextStyle(
                      //             fontSize: 17,
                      //             fontWeight: FontWeight.w500,
                      //             color: _uikGWListTileProps.listItemTextColor),
                      //       )
                      //     :
                      _uikGWListTileProps.title ?? Container(),
                      // _uikGWListTileProps.subTitleText != null
                      //     ? Text(
                      //         _uikGWListTileProps.subTitleText!,
                      //         style: const TextStyle(
                      //           fontSize: 14.5,
                      //           color: Colors.black54,
                      //         ),
                      //       )
                      //     :
                      _uikGWListTileProps.subTitle ?? Container(),
                      _uikGWListTileProps.description ?? Container()
                    ],
                  ),
                ),
              ),
              _uikGWListTileProps.icon ?? Container(),
            ],
          ),
        ),
      ),
    );
  }
}
