import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikAvatar.dart';
import 'package:ui_sdk/components/UikIcon.dart';
import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/getWidgets/uikListTile/UikGWListTileProps.dart';
import 'package:ui_sdk/props/UikAvatarProps.dart';
import 'package:ui_sdk/props/UikIconProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:ui_sdk/utils/extensions.dart';

UikGWListTileProps $UikGWListTilePropsFromJson(Map<String, dynamic> json) {
  UikGWListTileProps uikGWListTileProps = UikGWListTileProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikGWListTileProps.id = id;
  }
  final String? color = jsonConvert.convert<String>(json['color']);
  if (color != null) {
    uikGWListTileProps.color = color.toColor();
  }
  final String? focusColor = jsonConvert.convert<String>(json['focusColor']);
  if (focusColor != null) {
    uikGWListTileProps.color = focusColor.toColor();
  }
  final String? listItemTextColor =
      jsonConvert.convert<String>(json['listItemTextColor']);
  if (listItemTextColor != null) {
    uikGWListTileProps.color = listItemTextColor.toColor();
  }
  final String? hoverColor = jsonConvert.convert<String>(json['hoverColor']);
  if (hoverColor != null) {
    uikGWListTileProps.color = hoverColor.toColor();
  }

  final double? margin = jsonConvert.convert(json['margin']);
  if (margin != null) {
    uikGWListTileProps.margin = EdgeInsets.symmetric(
      horizontal: margin,
      vertical: margin,
    );
  }
  final double? padding = jsonConvert.convert(json['padding']);
  if (padding != null) {
    uikGWListTileProps.padding = EdgeInsets.symmetric(
      horizontal: padding,
      vertical: padding,
    );
  }

  final bool? autofocus = jsonConvert.convert(json['autofocus']);
  if (autofocus != null) {
    uikGWListTileProps.autofocus = autofocus;
  }
  final bool? selected = jsonConvert.convert(json['selected']);
  if (selected != null) {
    uikGWListTileProps.selected = selected;
  }
  final bool? enabled = jsonConvert.convert(json['enabled']);
  if (enabled != null) {
    uikGWListTileProps.selected = enabled;
  }

  final String? icon = jsonConvert.convert(json['icon']);
  if (icon != null) {
    uikGWListTileProps.icon = UikIcon(
      WidgetType.UikIcon,
      UikIconProps.fromJson(
        json['icon'],
      ),
    );
  }

  final String? title = jsonConvert.convert<String>(json['title']);
  final String? titleType = jsonConvert.convert(json['titleType']);
  if (title != null) {
    if (titleType == 'text') {
      uikGWListTileProps.title = UikText(
        WidgetType.UikText,
        UikTextProps.fromJson(
          json['title'],
        ),
      );
    }
  }
  final String? avatar = jsonConvert.convert(json['avatar']);
  if (avatar != null) {
    uikGWListTileProps.avatar = UikAvatar(
      WidgetType.UikAvatar,
      UikAvatarProps.fromJson(json['avatar']),
    );
  }

  final String? subTitle = jsonConvert.convert<String>(json['subTitle']);
  final String? subTitleType = jsonConvert.convert(json['subTitle']);
  if (subTitle != null) {
    if (subTitleType == 'text') {
      uikGWListTileProps.subTitle = UikText(
        WidgetType.UikText,
        UikTextProps.fromJson(
          json['subTitle'],
        ),
      );
    }
  }
  final String? description = jsonConvert.convert<String>(json['description']);
  final String? descriptionType = jsonConvert.convert(json['description']);
  if (description != null) {
    if (descriptionType == 'text') {
      uikGWListTileProps.description = UikText(
        WidgetType.UikText,
        UikTextProps.fromJson(
          json['description'],
        ),
      );
    }
  }

  return uikGWListTileProps;
}
