import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/generated/json/uik_card_props.g.dart';
import 'package:ui_sdk/getWidgets/uikButtonBar/UikButtonBar.dart';
import 'package:ui_sdk/getWidgets/uikListTile/UikGWListTile.dart';
import 'package:ui_sdk/getWidgets/uikPosition/UikPositon.dart';
import 'package:ui_sdk/props/WidgetProps.dart';

@JsonSerializable()
class UikCardProps extends WidgetProps {
  String? id;
  Color? color;
  double? height;
  double? elevation;
  UikPosition? titlePosition;
  ShapeBorder? shape;
  bool borderOnForeground = true;
  Clip? clipBehavior;
  EdgeInsetsGeometry? margin;
  EdgeInsetsGeometry padding =
      const EdgeInsets.symmetric(horizontal: 12, vertical: 8);
  UikGWListTile? title;
  Widget? content;
  bool showImage = false;
  bool showOverlayImage = false;
  Image? image;

  Widget? overlayImage;
  UikButtonBar? buttonBar;

  //  BoxFit? boxFit;
  //  ColorFilter? colorFilter;
  BorderRadiusGeometry? borderRadius;

  // Border? border;
  LinearGradient? gradient;

  UikCardProps();

  factory UikCardProps.fromJson(Map<String, dynamic> json) =>
      $UikCardPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }

  UikCardProps mockWidget() {
    return UikCardProps.fromJson({
      "id": "UikCard",
      "titlePosition": "start",
      "color": "0xFF4297C3",
      "height": 350.0,
      "margin": 12.0,
      "clipBehavior": "none",
      // "title": {"id": "title",
      //   "titleType":"text",
      //   "title": {
      //     "id": "text",
      //     "text": "Hello this is title",
      //     "size": "26.0",
      //     "action": {
      //       "tap": {
      //         "type": "UIK_OPEN_WEB",
      //         "data": {
      //           "url":
      //           "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
      //         }
      //       }
      //     }
      //   },
      // },
      "image":
          "https://upload.wikimedia.org/wikipedia/commons/e/e7/Everest_North_Face_toward_Base_Camp_Tibet_Luca_Galuzzi_2006.jpg",
      "showImage": "true",
      // "buttonBar": {
      //   "id": "buttonBar",
      //   "textDirection": "ltr",
      //   "children": [],
      // },

      "contentType": "text",
      "content": {
        "id": "text",
        "text": "Mountains",
        "size": "24.0",
        "action": {
          "tap": {
            "type": "UIK_OPEN_WEB",
            "data": {
              "url":
                  "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
            }
          }
        }
      },
      // "gradient": ["0xFF4297C3", "0xFF7A3347", "0xFFA95023"],
    });
  }
}
