import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/generated/json/uik_cell_props.g.dart';
import 'package:ui_sdk/props/UikAction.dart';

import 'WidgetProps.dart';

@JsonSerializable()
class UikCellProps extends WidgetProps {
  late String id;
  late double widthSize = 343.0;
  late double heightSize = 64.0;
  late Widget titleText;
  late Widget? subtitleText = null;
  late Widget? leftElement = Icon(null);
  late Widget? rightElement = null;
  late double leftMargin = 0.0;
  late double rightMargin = 0.0;
  late double topMargin = 0.0;
  late double bottomMargin = 0.0;
  late double? contentPaddingLeft = 0.0;
  late double? contentPaddingRight = 0.0;
  late Color bgcolor = Colors.transparent;
  late UikAction action;

  UikCellProps();

  factory UikCellProps.fromJson(Map<String, dynamic> json) =>
      $UikCellPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
