import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/generated/json/uik_chips_props.g.dart';
import 'package:ui_sdk/props/UikAction.dart';

import 'WidgetProps.dart';

@JsonSerializable()
class UikChipsProps extends WidgetProps {
  late String id;
  late String text;
  late Widget deleteIcon = Icon(Icons.abc);
  late Widget avatar = CircleAvatar(
    backgroundImage: NetworkImage(
        "https://images.pexels.com/photos/213780/pexels-photo-213780.jpeg?auto=compress&cs=tinysrgb&dpr=1&w=500"),
  );
  late UikAction action;
  late double padding = 0.0;
  late Color backgroundColor = Colors.white;

  UikChipsProps();

  factory UikChipsProps.fromJson(Map<String, dynamic> json) =>
      $UikChipsPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
