import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';

import '../generated/json/uik_divider_props.g.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikDividerProps extends WidgetProps {
  late String id;
  late Color dividerColor = Colors.amber;
  late double widthSize = 343.0;
  late String corner = "rectangle";
  late String dividerSize = "small";

  UikDividerProps();

  factory UikDividerProps.fromJson(Map<String, dynamic> json) =>
      $UikDividerPropsFromJson(json);

  Map<String, dynamic> toJson() => $UikDividerPropsToJson(this);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
