import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/generated/json/uik_ListTile_props.g.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/utils/extensions.dart';

import 'WidgetProps.dart';


@JsonSerializable()
class UikListTileProps extends WidgetProps {
  late String id;
  late double rightMargin = 0.0;
  late double leftMargin = 0.0;
  late double topMargin = 0.0;
  late double bottomMargin = 0.0;
  late double trailingWidth = 0.0;
  late double trailingHeight = 0.0;
  late Widget? leading = const SizedBox.shrink();
  late Widget? title = const SizedBox.shrink();
  late Widget? subtitle = const SizedBox.shrink();
  late Widget? trailing = const SizedBox.shrink();
  late bool isGradient = false;
  late List<Color>? gradientColors = ['#FFF3A5'.toColor(),'#FFF3A5'.toColor()];
  late UikAction action;

  UikListTileProps();

  factory UikListTileProps.fromJson(Map<String, dynamic> json) =>
      $UikListTilePropsFromJson(json);

  Map<String, dynamic> toJson() => $UikListTilePropsToJson(this);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
