import 'dart:convert';

import 'package:ui_sdk/generated/json/base/json_field.dart';

import '../generated/uik_lokal_academy_card_props.g.dart';
import 'UikButtonProps.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikLokalAcademyCardProps extends WidgetProps {
  late String id;
  late String logoPath;
  late String cardType;
  late String title;
  late String content;
  late String reward;
  late UikButtonProps buttonText;
  double width;
  double height;
  double logoWidth;
  double logoHeight;
  double titleFontSize;
  double contentFontSize;

  UikLokalAcademyCardProps({
    this.logoPath = "",
    this.cardType = "",
    this.title = "",
    this.content = "",
    this.reward = "",
    this.width = 0,
    this.height = 0,
    this.logoWidth = 0,
    this.logoHeight = 0,
    this.titleFontSize = 0,
    this.contentFontSize = 0,
    UikButtonProps? buttonText,
  }) {
    this.buttonText = buttonText ?? UikButtonProps();
  }

  factory UikLokalAcademyCardProps.fromJson(Map<String, dynamic> json) =>
      $UikLokalAcademyCardPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
