import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/props/UikAction.dart';

import '../generated/json/uik_navbar_props.g.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikNavbarProps extends WidgetProps {
  late String id;
  late String size = 'small';
  late Color? backgroundColor = Color(0xfffefefe);
  late bool? transparency = false;
  late String? titleText = null;
  late bool? titleTextCenter = null;
  late String? subtitleText = null;
  late Widget? leftIcon = Icon(null);
  late String? triggerElementType = null;
  late Widget? triggerIcon;
  late Widget? triggerButton;
  late Widget? triggerAction;

  late UikAction action;

  UikNavbarProps();

  factory UikNavbarProps.fromJson(Map<String, dynamic> json) =>
      $UikNavbarPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
