import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/UikOrderProductCardProps.g.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/WidgetProps.dart';

@JsonSerializable()
class UikOrderProductCardProps extends WidgetProps {
  late UikAction action;
  late String id;
  double? height;
  double? width;
  bool enablePadding = false;
  double leftMargin = 0;
  double rightMargin = 0;
  double topMargin = 0;
  double bottomMargin = 0;
  double borderRadius = 8;
  double? opacity;
  late Color bgColor = Colors.transparent;
  List<Widget> widgetList = [];

  UikOrderProductCardProps();

  factory UikOrderProductCardProps.fromJson(Map<String, dynamic> json) =>
      $UikOrderProductCardPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
