import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/generated/json/uik_pagecontrol_props.g.dart';
import 'package:ui_sdk/props/UikAction.dart';

import 'WidgetProps.dart';

@JsonSerializable()
class UikPageControlProps extends WidgetProps {
  late String id;
  late List<Widget> list = [];
  late Color dotColor = Color(0xffe0e0e0);
  late Color activeDotColor = Color(0xff212121);
  late double dotHeight = 5;
  late double dotWidth = 5;
  late bool isBackground = true;
  late Color backgroundColor = Color(0xffffffff);
  late double spacing = 4;
  late double dotRadius = 2.5;
  late double contentWidth;
  late double contentHeight;
  late UikAction action;

  UikPageControlProps();

  factory UikPageControlProps.fromJson(Map<String, dynamic> json) =>
      $UikPageControlPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
