import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/props/UikAction.dart';

import '../generated/json/uik_pagination_props.g.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikPaginationProps extends WidgetProps {
  late String id;
  late String text;
  late List<dynamic> iconList = [];
  late List<dynamic> imgList = [];
  late BoxFit iFit = BoxFit.cover;
  late bool hasIcons = false;
  late double imagePadding = 0.0;
  late Widget Icon1 = Icon(Icons.abc);
  late Widget Icon2 = Icon(Icons.abc);
  late Widget Icon3 = Icon(Icons.abc);
  late double imageLeftMargin = 0.0;
  late double imageRightMargin = 0.0;
  late double imageBottomMargin = 0.0;
  late double imageTopMargin = 0.0;

  late UikAction action;

  UikPaginationProps();

  factory UikPaginationProps.fromJson(Map<String, dynamic> json) =>
      $UikPaginationPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
