import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/props/UikAction.dart';

import '../generated/json/uik_product_props.g.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikProductProps extends WidgetProps {
  late String imgUrl;
  late String imgPrice;
  late String imgDescription;
  late double imgRating;
  late Widget starIcon = Icon(Icons.star);
  late Widget heartIcon = Icon(Icons.favorite_border_outlined);

  late String id;
  late String text;
  late UikAction action;

  UikProductProps();

  factory UikProductProps.fromJson(Map<String, dynamic> json) =>
      $UikProductPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
