import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/props/UikAction.dart';

import '../generated/json/uik_scroll_products.g.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikScrollProductsProps extends WidgetProps {
  late List<dynamic> items = [];
  late Axis scrollAxis = Axis.vertical;
  late double height = 0.0;
  late String? type = "";
  late double width = 0.0;
  late double gapBetweenItems = 0.0;
  late double topHeadingMargin = 0.0;
  late double bottomHeadingMargin = 0.0;
  late double leftHeadingMargin = 0.0;
  late double rightHeadingMargin = 0.0;
  late double headingWidth = 0.0;
  late double headingHeight = 0.0;
  late double topMargin = 0.0;
  late double bottomMargin = 0.0;
  late double leftMargin = 0.0;
  late double rightMargin = 0.0;

  late String id;
  late Widget? heading = null;
  late UikAction action;

  UikScrollProductsProps();

  factory UikScrollProductsProps.fromJson(Map<String, dynamic> json) =>
      $UikScrollProductsPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}

const itemType_image = "image";
const itemType_product_card = "product_card";
const itemType_row = "row";
const itemType_three_text_column = "three_text_column";
const itemType_lokalAcademy = "lokalAcademy";
