import 'dart:convert';
import 'package:flutter/material.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/WidgetProps.dart';
import '../generated/json/uik_simplerow.props.g.dart';

class UikSimpleRowProps extends WidgetProps {
  late String id;
  late double height = 0.0;
  late List<Widget> widgets = [];
  late double leftMargin = 0.0;
  late double topMargin = 0.0;
  late double rightMargin = 0.0;
  late double bottomMargin = 0.0;
  late UikAction action;
  Alignment alignment = Alignment.center;
  MainAxisAlignment mainAxisAlignment = MainAxisAlignment.start;
  CrossAxisAlignment crossAxisAlignment = CrossAxisAlignment.center;

  UikSimpleRowProps();
  factory UikSimpleRowProps.fromJson(Map<String, dynamic> json) =>
      $UikSimpleRowPropsFromJson(json);

  Map<String, dynamic> toJson() => $UikSimpleRowPropsToJson(this);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
