import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/props/UikAction.dart';

import '../generated/json/uik_stepper_props.g.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikStepperProps extends WidgetProps {
  late int upperLimit = 9;
  late int lowerLimit = 0;
  late Widget minusIcon = Icon(Icons.remove);
  late Widget plusIcon = Icon(Icons.add);
  late String id;
  late String text;
  late UikAction action;

  UikStepperProps();

  factory UikStepperProps.fromJson(Map<String, dynamic> json) =>
      $UikStepperPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
