import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/generated/json/uik_tags_props.g.dart';
import 'package:ui_sdk/props/UikAction.dart';

import 'WidgetProps.dart';

@JsonSerializable()
class UikTagsProps extends WidgetProps {
  late String id;
  late Widget? avatar = null;
  late Widget? text;
  late Color textColor = Colors.white;
  late Color backgroundColor = Colors.black;
  late double width = 0.0;
  late double height = 0.0;
  // ignore: avoid_init_to_null
  late Color? borderColor = null;
  late UikAction action;

  UikTagsProps();

  factory UikTagsProps.fromJson(Map<String, dynamic> json) =>
      $UikTagsPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
