import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/props/UikAction.dart';

import '../generated/json/uik_textarea_props.g.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikTextAreaProps extends WidgetProps {
  late String id;
  late bool transparency;
  late Color? backgroundColor = Color.fromARGB(255, 236, 233, 233);
  late double width;
  late double height;
  late bool isLabel;
  late String label;
  late String text;
  late String corner;
  late bool isBorder;
  late Color? borderColor = Colors.black;
  late UikAction action;

  UikTextAreaProps();

  factory UikTextAreaProps.fromJson(Map<String, dynamic> json) =>
      $UikTextAreaPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
