import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/props/UikAction.dart';

import '../generated/json/uik_textField_props.g.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikTextFieldProps extends WidgetProps {
  late String id;
  late double leftMargin = 0.0;
  late double rightMargin = 0.0;
  late double topMargin = 0.0;
  late double bottomMargin = 0.0;
  late String description = "";
  late String? labelText = null;
  late String hintText = "";
  late Widget? rightElement = null;
  late double width = 0.0;
  late double height = 0.0;
  late Widget? leftElement = null;
  late bool error = false;
  late UikAction action;

  UikTextFieldProps();

  factory UikTextFieldProps.fromJson(Map<String, dynamic> json) =>
      $UikTextFieldPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
