import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/props/UikAction.dart';

import '../generated/json/uik_textradiobutton_props.g.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikTextRadioButtonProps extends WidgetProps {
  late String id;
  late UikAction action;
  late Widget? text;
  // late dynamic itemList = [];
  late Widget? radiobutton;
  double marginLeft;
  double marginRight;
  double marginTop;
  double marginBottom;

  UikTextRadioButtonProps({
    this.marginBottom = 0.0,
    this.marginLeft = 0.0,
    this.marginRight = 0.0,
    this.marginTop = 0.0,
  });

  factory UikTextRadioButtonProps.fromJson(Map<String, dynamic> json) =>
      $UikTextRadioButtonPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
