import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/props/UikAction.dart';

import '../generated/json/uik_twocomponentrow_props.g.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikTwoComponentRowProps extends WidgetProps {
  late String id;
  late UikAction action;
  late double height = 0.0;
  late Widget? firstComponent = Container();
  late Widget? secondComponent = Container();
  MainAxisAlignment mainAxisAlignment = MainAxisAlignment.spaceBetween;
  bool enablePadding = false;
  double marginLeft = 0;

  double marginRight = 0;
  double marginTop = 0;
  double marginBottom = 0;
  double borderRadius = 8;
  double? opacity = null;
  late Color bgcolor = Colors.transparent;

  UikTwoComponentRowProps();

  factory UikTwoComponentRowProps.fromJson(Map<String, dynamic> json) =>
      $UikTwoComponentRowPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
