
import 'dart:convert';
import 'dart:ui';

import 'package:ui_sdk/props/UikAction.dart';
import 'package:youtube_player_flutter/youtube_player_flutter.dart';

import '../generated/json/Uik_video_player_new_props.g.dart';
import '../generated/json/base/json_field.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikVideoPlayerNewProps extends WidgetProps {
  late String id;
  String? videoUrl;
  late bool showVideoProgressIndicator = false;
  late double aspectRatio=1.0;
  late Color progressIndicatorColor = const Color(0xFF00000);
  late double width = 0.0;
  late UikAction action;
  late YoutubePlayerController controller = YoutubePlayerController(
      initialVideoId: "123",
      flags: const YoutubePlayerFlags(
        autoPlay: false,
      ));
  UikVideoPlayerNewProps();

  factory UikVideoPlayerNewProps.fromJson(Map<String, dynamic> json) =>
      $UikVideoPlayerNewPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}